/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_config.h 698 2012-07-11 08:12:24Z nces-mtakada $
 */

/*
 *		vZbTˑW[iSH34pj
 *
 *  ̃CN[ht@ĆCtarget_config.hi܂́CCN
 *  [ht@Cĵ݂CN[hD̃t@C
 *  ڃCN[hĂ͂ȂȂD
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  vZbT̓ꖽ߂̃CC֐`
 */
#include "prc_insn.h"

/*
 *  ^[Qbg`̃IuWFNg
 */
#define TARGET_INHATR	TA_NONKERNEL	/* J[lǗO̊ */
#define TARGET_INTATR	(TA_NEGEDGE|TA_POSEDGE) /* ݑ̃^[Qbgˑɗprbg */

/*
 *  G[`FbN@̎w
 */
#define CHECK_STKSZ_ALIGN	4	/* X^bNTCỸACP */
#define CHECK_FUNC_ALIGN	4	/* ֐̃ACP */
#define CHECK_FUNC_NONNULL		/* ֐̔NULL`FbN */
#define CHECK_STACK_ALIGN	4	/* X^bN̈̃ACP */
#define CHECK_STACK_NONNULL		/* X^bN̈̔NULL`FbN */
#define CHECK_MPF_ALIGN		4	/* Œ蒷v[̈̃ACP */
#define CHECK_MPF_NONNULL		/* Œ蒷v[̈̔NULL`FbN */
#define CHECK_MB_ALIGN		4	/* Ǘ̈̃ACP */
/*
 *  ^XNReLXgp̃X^bNl
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))

/*
 *  ^XNReLXgubN̒`
 */
typedef struct task_context_block {
	void	*ssp;		/* VXeX^bN|C^ */
	void	*usp;		/* [UX^bN|C^ */
    bool_t  priv_mode;  /* [hs */
	FP		pc;			/* vOJE^ */
} TSKCTXB;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ݗDx}XN색Cu
 *  
 *  SH34ł́CXe[^XWX^iSRj4`7rbg߂4rbgɊݗDx
 *  }XNin[hEFÅݗDx}XNCIPMjuĂDIPM
 *  Ă߂ɁCݗDx̊O\i-1A̒ljg
 *  Ƃ\ł邪C]vȍErbgVtgƕ]KvɂȂD
 *  邽߂ɁCIPMۑꍇɂ́CSR4`7rbg߂ol
 *  gƂɂD̒lݗDx}XN̓\ƌĂсCIIPMƏ
 *  ƂɂD
 */

/*
 *  ݗDx}XN̊O\Ɠ\̕ϊ
 *
 *  AZũ\[Xt@CCN[hꍇ̂߂ɁCCASTgp
 */
#define EXT_IPM(iipm)    (-CAST(PRI,(iipm) >> 4))       /* \O\ */
#define INT_IPM(ipm)     (CAST(uint16_t, -(ipm)) << 4)  /* O\\ */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  IPMin[hEFÅݗDx}XNC\ǰݒl̓Ǐo
 */
Inline uint8_t
current_iipm(void)
{
    return((uint8_t)(current_sr() & 0xF0U));
}

/*
 *  IPMin[hEFÅݗDx}XNC\ǰݒl̐ݒ
 */
Inline void
set_iipm(uint8_t iipm)
{
    set_sr((current_sr() & ~0xF0U) | iipm);
}

/*
 *  TOPPERSWݏf̎
 *
 *  SH34̓Xe[^XWX^(SR)ɊݗDx}XN(IPM)ĂD
 *  CPUbNtOɑ@\ȂD̂߁C[ICPUbNt
 *  OD
 *
 *  ܂CCPUbNԂǗ߂̕ϐ(lock_flag)pӂD
 *
 *  CPUbNtONAĂԂ́CIPMf̊ݗDx
 *  }XN̒lɐݒ肷D̊Ԃ́Cf̊ݗDx}XŃC
 *  IPMpD
 * 
 *  ɑ΂CPUbNtOZbgꂢԂ́CIPMCJ[l
 *  Ôׂ̂Ă̊ݗv}XNl(TIPM_LOCK)ƁCf
 *  ̊ݗDx}XNƂ̍ɐݒ肷D̊Ԃ̃f̊
 *  ݗDx}XŃĈ߂̕ϐ(saved_iipm, \ŕێ)p
 *  ӂĕێD
 */

/*
 *  r7_bankWX^QƂ֐
 *  HEWł̓CCAZüȂ̂
 *  prc_supportɂĎ
 */
extern uint32_t get_r7_bank(void);

/*
 *  ReLXg̎Q
 *
 *  SH34ł́CReLXg̔ɁC݂̃lXg񐔂Ǘ
 *  R7_BANK1pD
 * 
 */
Inline bool_t
sense_context(void)
{
    uint32_t nest;

    nest = get_r7_bank();
    return(nest > 0U);
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPUbNԂł̊ݗDx}XN
 *
 *  TIPM_LOCḰCCPUbNԂł̊ݗDx}XNCȂ킿CJ[l
 *  ǗÔׂ̂Ă݂̊}XNlɒ`D
 */
#define TIPM_LOCK    TMIN_INTPRI

/*
 *  CPUbNԂł̊ݗDx}XN̓\
 */
#define IIPM_LOCK    INT_IPM(TIPM_LOCK)

/*
 *  TIPM_ENAALLiݗDx}XNSj̓\
 */
#define IIPM_ENAALL  INT_IPM(TIPM_ENAALL)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  CPUbNtÔ߂̕ϐ
 * 
 *  ̕ϐ́CCPUbNԂ̎̂ݏĂ悢ƂD
 *  CC֐ŁCANZX̏ωȂ悤Cvolatile wD 
 */
extern volatile bool_t    lock_flag;   /* CPUbNtO̒lێϐ */
extern volatile uint8_t saved_iipm;  /* ݗDx}XNϐ */

/*
 *  CPUbNԂւ̈ڍs
 *
 *  IPMin[hEFÅݗDx}XNjCsaved_iipmɕۑCJ[
 *  lǗÔׂ̂Ă݂̊}XNliTIPM_LOCKjɐ
 *  肷D܂Clock_flagtrueɂD
 *
 *  IPMCŏTIPM_LOCKƓ荂ꍇɂ́C
 *  saved_iipmɕۑ݂̂ŁCTIPM_LOCKɂ͐ݒ肵ȂD́Cf
 *  ̊ݗDx}XNCTIPM_LOCKƓ荂xɐݒ
 *  ĂԂɂD
 *
 *  ̊֐́CCPUbNԁilock_flagtruȅԁjŌĂ΂邱Ƃ
 *  Ȃ̂Ƒz肵ĂD
 */
Inline void
x_lock_cpu(void)
{
    uint8_t iipm;

    /*
     *  current_iipm()̕Ԃl𒼐saved_iipmɕۑCꎞϐiipm
     *  pĂ̂́Ccurrent_iipm()Ă񂾒Ɋ݂C
     *  Nꂽݏsaved_iipmύX\邽߂
     *  D
     */
    iipm = current_iipm();
    if (IIPM_LOCK > iipm) {
        set_iipm(IIPM_LOCK);
    }
    saved_iipm = iipm;
    lock_flag = true;
    /* NeBJZNV̑OŃ\ */
    /* shcł͍lKv͂Ȃ */  
    /* Asm("":::"memory"); */
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUbNԂ̉
 *
 *  lock_flagfalseɂCIPMin[hEFÅݗDx}XNjC
 *  saved_iipmɕۑlɖ߂D
 *
 *  ̊֐́CCPUbNԁilock_flagtruȅԁjł̂݌Ă΂
 *  ̂Ƒz肵ĂD
 */
Inline void
x_unlock_cpu(void)
{
    /* NeBJZNV̑OŃ\ */
    /* shcł͍lKv͂Ȃ */  
    /* Asm("":::"memory"); */
    lock_flag = false;
    set_iipm(saved_iipm);
}

#define t_unlock_cpu()    x_unlock_cpu()
#define i_unlock_cpu()    x_unlock_cpu()

/*
 *  CPUbNԂ̎Q
 */
Inline bool_t
x_sense_lock(void)
{
    return(lock_flag);
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()

/*
 *  chg_ipmŗLȊݗDx͈̔͂̔
 *
 *  TMIN_INTPRI̒lɂ炸Cchg_ipmł́C-15`TIPM_ENAALLi0j͈̔
 *  ɐݒł邱ƂƂi^[Qbg`̊gjD
 */
#define VALID_INTPRI_CHGIPM(intpri) \
				((-15 <= (intpri) && (intpri) <= TIPM_ENAALL))

/*
 * if́jݗDx}XN̐ݒ
 *
 *  CPUbNtONAĂ鎞́Cn[hEFÅݗDx}
 *  XNݒ肷DCPUbNtOZbgĂ鎞́Csaved_iipm
 *  ݒ肵CɁCn[hEFÅݗDx}XNCݒ肵悤
 *  if́jݗDx}XNTIPM_LOCK̍ɐݒ肷D
 */
Inline void
x_set_ipm(PRI intpri)
{
    uint8_t   iipm = INT_IPM(intpri);

    if (!lock_flag) {
        set_iipm(iipm);
    }
    else {
        saved_iipm = iipm;
#if TIPM_LOCK == -15
        /*
         *  TIPM_LOCK-15̏ꍇɂ́C̎_Ńn[hEFÅݗD
         *  x}XNK15ɐݒ肳Ă邽߁Cݒ肵ȂKvȂD
         */
#else /* TIPM_LOCK == -15 */
        set_iipm(iipm > IIPM_LOCK ? iipm : IIPM_LOCK);
#endif /* TIPM_LOCK == -15 */
    }
}

#define t_set_ipm(intpri)    x_set_ipm(intpri)
#define i_set_ipm(intpri)    x_set_ipm(intpri)

/*
 * if́jݗDx}XN̎Q
 *
 *  CPUbNtONAĂ鎞̓n[hEFÅݗDx}
 *  XNCZbgĂ鎞saved_iipmQƂD
 */
Inline PRI
x_get_ipm(void)
{
    uint8_t iipm;

    if (!lock_flag) {
        iipm = current_iipm();
    }
    else {
        iipm = saved_iipm;
    }
    return(EXT_IPM(iipm));
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *  ōD揇ʃ^XNւ̃fBXpb`iprc_support.Sj
 *
 *  dispatch́C^XNReLXgĂяoꂽT[rXR[
 *  ĂяôׂŁC^XNReLXgECPUbNԁEfBXpb
 *  `ԁEif́jݗDx}XNSԂŌĂяo
 *  ΂ȂȂD
 */
extern void dispatch(void);

/*
 *  fBXpb`̓Jniprc_support.Sj
 *
 *  start_dispatch́CJ[lNɌĂяôׂŁCׂĂ̊
 *  ݂֎~ԁi݃bNԂƓ̏ԁjŌĂяoȂ
 *  ȂȂD
 */
extern void start_dispatch(void);

/*
 *  ݂̃ReLXĝĂăfBXpb`iprc_support.Sj
 *
 *  exit_and_dispatch́Cext_tskĂяôׂŁC^XNReL
 *  XgECPUbNԁEfBXpb`ԁEif́jݗD
 *  x}XNSԂŌĂяoȂ΂ȂȂD
 */
extern void exit_and_dispatch(void);

/*
 *  J[l̏Ǐďoiprc_support.Sj
 *
 *  call_exit_kerneĺCJ[l̏IɌĂяôׂŁC^XN
 *  ReLXgɐ؂芷āCJ[l̏Iiexit_kerneljĂяo
 *  D
 */
extern void call_exit_kernel(void);

/*
 *  ^XNReLXg̏
 *
 *  ^XNx~ԂsłԂɈڍs鎞ɌĂ΂D̎_
 *  ŃX^bN̈gĂ͂ȂȂD
 *
 *  activate_contextCCC֐ł͂Ȃ}N`ƂĂ̂́C
 *  ̎_łTCB`ĂȂ߂łD
 */

extern void    start_stask_r(void);
extern void    start_utask_r(void);
#undef activate_context
#define activate_context(p_tcb)                                         \
{\
	(p_tcb)->tskctxb.ssp = (p_tcb)->p_tinib->tskinictxb.sstk_bottom;	\
	(p_tcb)->tskctxb.pc = ((p_tcb)->p_tinib->p_dominib->domptn == TACP_KERNEL) ? (FP)start_stask_r: (FP)start_utask_r;       \
	(p_tcb)->tskctxb.priv_mode = 0U; \
}

/*
 *  calltex͎gpȂ
 */
#define OMIT_CALLTEX

/*
 * ^[QbgˑɊ܂܂W̗OǗ@\̏pȂ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPUOnh̏
 */
Inline void
initialize_exception(void)
{
}
     
/*
 *  SH34̊݃A[LeN`Ɗݏf̎
 * 
 *  SH34݂̊́CӃW[݁CIRQ, PINT݂ɕ
 *  ނłCꂼꈵقȂD̂߁C݃nhԍC
 *  ݂̊ɕނ邽߂̃}NpӂD
 * 
 *  PINT݂15bit̃vZbTւ̊ݗvCŎĂ邪C
 *  IRCւ̊ݗvCPINT0`PINT7PINT0`PINT7Ƃ2{ɂȂ
 *  ĂD̂߁CJ[lłʂɂ͈킸C2{݂̊ƂĈD
 *  PINT́CʂPINTERWX^ɂ苖֎~\ł邪CJ[l
 *  ́CPINTERWX^̐ݒ͎舵ȂD̂߁CPINTERWX^
 *  ݒ́C[U[vOōsKvDlPINT̗vx
 *  ݒ肷ICR2̐ݒ[U[vOōsKvDȂCGb
 *  W݂ɐݒ肵ۂ̊݃nh̓łIRR0̃NA
 *  i_begin_int()ōsDPINT݂ǂ𔻒肷}NpӂD
 *
 *  lIRQ݂𔻒肷}NpӂD
 */

/*
 *  PINT݂ǂ𔻒肷邽߂̃}N
 */
#define INTNO_PINT(intno) ((0x700 == (intno)) || (0x720 == (intno)))
#define INTNO_PINT_OFFSET(intno) (((intno) - 0x700) >> 5)

/*
 *  IRQ݂ǂ𔻒肷邽߂̃}N
 */
#define INTNO_IRQ(intno) ((TMIN_IRQNO <= (intno)) && ((intno) <= TMAX_IRQNO))
#define INTNO_IRQ_OFFSET(intno) (((intno) - TMIN_IRQNO) >> 5)
     
/*
 *  ݗDx
 *
 *  e݂̊ݗDx͊ݗD揇ݒ背WX^(IPRXX)ɂĐ
 *  肷DӃW[̏ꍇCӃW[ɐݒ\łD
 *  ႦSCIF́CERI2, RXI2, BRI2, TXI2Ƃ4̊ݗvCT
 *  |[g邪CSĂ̊ݗvCɑ΂ē̗Dxݒ
 *  ȂD̂߁CeݗvCɂǂ̊ݗD揇ݒ背WX
 *  ^ݒ肷邩`e[upӂD܂Cݔԍ͘A
 *  Ă߁CT|[gĂȂԍɂ́Cnumber-1ݒ肷De[
 *  u
 */

/*
 *  eݔԍ̐ݒ肷IPȐǗ̂߂̍\  
 */
typedef struct {
    /* IPR̃AhX */
    uint32_t address; 
    /* IPȒΏۃtB[hւ̃ItZbg */
    uint8_t  offset;
} IPR_INFO;

/*
 *  eݔԍIPȐǗe[u
 */
extern const IPR_INFO ipr_info_tbl[TNUM_INH];
    
/*
 *  ݔԍE݃nhԍ
 *
 *  ݃nhԍ(inhno)Ɗݔԍ(intno)́CݔɊ
 *  ݎۃWX^ɐݒ肳lpDݎۃWX^́CINTEVT
 *  INTEVT22ނCꂼݒ肳lقȂDSH34
 *  INTEVTgpĂC݂INTEVT2pD̂߁CvZ
 *  bŤ^Ԗ̒`t@CpӂāCǂ̃WX^p邪
 *  肷邱ƂƂD܂CT|[g銄݂̍ő吔قȂ邽߁C
 *  őlvZbŤ^Ԗ̒`t@Cɒ`D
 *
 *  INTENTɐݒ肳l̓Xp[XȒlł邽߁Ĉ܂܂̒lDx
 *  Ǘ̃e[ũCfbNXɗpƁCʂȗ̈悪D
 *  ̂߁CJ[lł́CINTENTɐݒ肳lVtglp
 *  DVtglvZbTɈقȂ邽߃vZbŤ^Ԗ̒`
 *  t@Cɒ`D
 *
 *  \̖ÓCiintno,iinhnoƂD
 */

/*
 *  ݔԍ͈̔͂̔
 * 
 *  TMIN_INTNOTMAX_INTNO͈̔͂łĂLȔԍłȂꍇ邽
 *  ߁Cipr_info_tbl[]ŗLȔԍ`FbN
 */
#define VALID_INTNO(intno) \
        ((TMIN_INTNO <= (intno)) && ((intno) <= TMAX_INTNO) && (ipr_info_tbl[INT_INTNO(intno)].address != 0U))
#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)    VALID_INTNO(intno)

/*
 *  CPUOnhԍ
 *
 *  CPUOnhԍƂẮCOۃWX^ɐݒ肷OR[h
 *  pDT|[gCPUOnh̓vZbŤ^ԖɈقȂ
 *  ŁCvZbŤ^Ԗ̒`t@Cɒ`D
 *
 *  ݃nhԍƓCCPUOnhԍXp[Xł邽߁C
 *  J[lł͒lVtg\pD 
 */
#define VALID_EXCNO_DEFEXC(excno) \
        (TMIN_EXCNO <= (excno) && (excno) <= TMAX_EXCNO)

/*
 *  ݃nh
 *
 *  ݃nho^D݃nhe[û̓RtBM
 *  [^ŐÓIɐ
 */ 
extern const FP inh_tbl[TNUM_INH];

/*
 *  ݃nh̐ݒ
 *
 *  xNgԍinhno̊݃nh̋NԒnint_entryɐݒ肷D
 *  nhe[u
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry)
{
}

/*
 *  ݃nh̏o̐}N
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);

/*
 *  ݗv֎~tO
 *
 *  SH34IRC͊ݗv֎~tOȂD݂֎~ꍇ́C
 *  ݗD揇ݒ背WX^(IPRXX)0ɐݒ肷KvDݗD
 *  揇ݒ背WX^0ɂ邱ƂŊݗv֎~tOƂ
 *  ԁCݗDxLĂ̈悪KvƂȂDRtBM[^
 *  ł̃e[upӂDȂC̃e[u݂͊̓Ŋ
 *  ݗvɉSRɐݒ肷Kv邽߁C\ƂD܂C
 *  ݃nh̓ł̗֐̂߁CIPMł͂ȂC݃nh
 *  sSR̐ݒɎD̂߁CIPM̒l݂̂擾
 *  ́C8bit݂̂QƂKvDe̓RtBM[^
 *  ÓIɐD
 */
extern const uint32_t int_iipm_tbl[TNUM_INT];

/*
 *  ݗv֎~tÕZbg
 *
 *  ݗD揇ݒ背WX^(IPRA`G)0ɐݒ肷D
 *
 *  ݑݒ肳ĂȂݗvCɑ΂Ċݗv֎~
 *  tONA悤Ƃꍇɂ́CfalseԂD
 */
Inline bool_t
x_disable_int(INTNO intno)
{
    uint16_t iintno  = INT_INTNO(intno);
    uint32_t address = ipr_info_tbl[iintno].address;
    uint32_t offset  = ipr_info_tbl[iintno].offset;
    uint32_t iipm    = int_iipm_tbl[iintno];

    /*
     *  ݑݒ肳ĂȂꍇ
     */
    if ((iipm & 0x01U) != 0) {
        return(false);
    }
    
    /* 
     *  ݔԍɑΉIPR̒l0ɂD
     */
    set_irc_ipr(address, offset, 0x00);

    return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ݗv֎~tỎ
 *
 *  ݗD揇ݒ背WX^(IPRA`G)̒lɖ߂D
 *
 *  ݑݒ肳ĂȂݗvCɑ΂Ċݗv֎~
 *  tONA悤Ƃꍇɂ́CfalseԂD
 */
Inline bool_t
x_enable_int(INTNO intno)
{
    uint16_t iintno  = INT_INTNO(intno);
    uint32_t address = ipr_info_tbl[iintno].address;
    uint32_t offset  = ipr_info_tbl[iintno].offset;
    uint32_t iipm    = int_iipm_tbl[iintno];

    /*
     *  ݑݒ肳ĂȂꍇ
     */
    if ((iipm & 0x01U) != 0) {
        return(false);
    }

    /* 
     *  ݔԍɑΉIPR̒lZbg
     */
    set_irc_ipr(address, offset, (-EXT_IPM(iipm & 0xF0U)));
    
    return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 *  ݗvC̑̐ݒ
 *
 *  SH34ł́CJ[lň銄ݗDx16iKł邽߁Cintpri
 *  Ƃė^邱Ƃłl-15`-1WłD
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ݃nhŕKvIRC
 *
 */
Inline void
i_begin_int(INTNO intno)
{
#ifdef SH3    
    uint8_t irr0_val;

    /*
     *  PINTEIRQ݂łCGbWgK̏ꍇ͊ݗvNAD
     *  GbWgKf̂ʓ|Ȃ̂ŁCɃNAD
     */
    if (INTNO_PINT(intno)) {
        irr0_val = sil_reb_mem((void *) IRR0);
        irr0_val &= ~(0x40U << INTNO_PINT_OFFSET(intno));
        sil_wrb_mem((void *) IRR0, irr0_val);
    }
    else if (INTNO_IRQ(intno)) {
        irr0_val = sil_reb_mem((void *) IRR0);
        irr0_val &= ~(0x01U << INTNO_IRQ_OFFSET(intno));
        sil_wrb_mem((void *) IRR0, irr0_val);
    }
#else /* SH4 */
    const uint32_t clear_tbl[8] = {
         0x01000000, /* IRQ7 */
         0x80000000, /* IRQ0 */
         0x40000000, /* IRQ1 */
         0x20000000, /* IRQ2 */
         0x10000000, /* IRQ3 */
         0x08000000, /* IRQ4 */
         0x04000000, /* IRQ5 */
         0x02000000  /* IRQ6 */
       };

    /*
     *  IRQn(n=0`7)݂łCGbWgK̏ꍇ͊ݗvNAD
     *  GbWgKf̂ʓ|Ȃ̂ŁCɃNAD
     */
    if (INTNO_IRQ(intno)) {
        sil_wrw_mem((void *)INTREQ, ~clear_tbl[((intno - TMIN_IRQNO) >> 6)]);
    }
#endif /* SH3 */
}

/*
 *  ݃nh̏oŕKvIRC
 */
Inline void
i_end_int(INTNO intno)
{
}

/*
 *  `̊݃nh(default_int_handler())̈ p_excinf
 *  eo߂̃}N
 */
#define P_EXCINF_INT_OFFSET_SSR     (13U)
#define P_EXCINF_INT_OFFSET_SPC     (15U)
#define P_EXCINF_INT_OFFSET_PR      (14U)

/*
 *  CPUOnh֌W
 */ 

/*
 *  Onh p_excinf eo߂̃}N
 */
#ifdef FPU_ENABLE

#ifdef FPU_SAVE_BANKED_REG

#define P_EXCINF_EXC_OFFSET_SSR     (12U + 14U + 16U)
#define P_EXCINF_EXC_OFFSET_SPC     (14U + 14U + 16U)
#define P_EXCINF_EXC_OFFSET_PR      (13U + 14U + 16U)
#define P_EXCINF_EXC_OFFSET_EXPEVT    0U 

#else

#define P_EXCINF_EXC_OFFSET_SSR     (12U + 14U)
#define P_EXCINF_EXC_OFFSET_SPC     (14U + 14U)
#define P_EXCINF_EXC_OFFSET_PR      (13U + 14U)
#define P_EXCINF_EXC_OFFSET_EXPEVT    0U

#endif /* FPU_SAVE_BANKED_REG */

#else

#define P_EXCINF_EXC_OFFSET_SSR     12U
#define P_EXCINF_EXC_OFFSET_SPC     14U
#define P_EXCINF_EXC_OFFSET_PR      13U
#define P_EXCINF_EXC_OFFSET_EXPEVT   0U

#endif /* FPU_ENABLE */

/*
 *  CPUOnh̓o^pe[u
 */
extern const FP exch_tbl[TNUM_EXC];

/*
 *  CPUOnh̐ݒ
 */
Inline void
x_define_exc(EXCNO excno, FP exc_entry)
{       
}

/*
 *  CPUOnh̓̐}N
 */
#define EXC_ENTRY(excno, exchdr)    exchdr
#define EXCHDR_ENTRY(excno, excno_num, exchdr) extern void exchdr(void *p_excinf);

/*
 *  CPUO̔̃ReLXg̎Q
 *
 *  CPUO̔̃ReLXgC^XNReLXg̎falseC
 *  łȂtrueԂD
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
    uint32_t nest;

    nest = get_r7_bank();
    return(nest > 1U);
}

/*
 *  CPUO̔IPMin[hEFÅݗDx}XNC\
 *  j̎Q
 */
Inline uint16_t
exc_get_iipm(void *p_excinf)
{
    return(*(((uint32_t *) p_excinf) + P_EXCINF_EXC_OFFSET_SSR) & 0x00F0U);
}

/*
 *  CPUO̔̃ReLXgƊ݂̃}XNԂ̎Q
 *
 *  CPUO̔̃VXeԂCJ[lsłȂC^XNR
 *  eLXgłC݃bNԂłȂCCPUbNԂłȂCi
 *  f́jݗDx}XNSԂł鎞trueCłȂ
 *  falseԂiCPUOJ[lǗO̊ݏŔꍇ
 *  ɂfalseԂjD
 *
 *  SHł́CCPUO̔IPMin[hEFÅݗDx}XNj
 *  ׂĂ݂̊Ԃł邱Ƃ`FbN邱ƂŁCJ[
 *  lsłȂƁC݃bNԂłȂƁCCPUbNԂł
 *  ƁCif́jݗDx}XNSԂł邱Ƃ4
 *  `FbN邱ƂłiCPUOlock_flagQ
 *  ƂKv͂ȂjD
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
    return(!exc_sense_context(p_excinf)
                    && exc_get_iipm(p_excinf) == IIPM_ENAALL);
}

/*
 * TrapaȊO̗Oœo^ĂȂOƌĂяo
 */
extern void default_exc_handler(void *p_excinf);

/*
 * o^݂̊ꍇɌĂяo
 */
extern void default_int_handler(void *p_excinf);

/*
 *  vZbTˑ̏
 */
extern void prc_initialize(void);

/*
 *  vZbTˑ̏I
 */
extern void prc_terminate(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
