;
;  startup.c
;
_kerflg:        .DEFINE "__kernel_kerflg"
_exit_kernel:   .DEFINE "__kernel_exit_kernel"

;
;  task.c
;
_p_runtsk:      .DEFINE "__kernel_p_runtsk"
_rundom:        .DEFINE "__kernel_rundom"
_p_ctxdom:      .DEFINE "__kernel_p_ctxdom"
_p_schedtsk:    .DEFINE "__kernel_p_schedtsk"
_reqflg:        .DEFINE "__kernel_reqflg"
_ipmflg:        .DEFINE "__kernel_ipmflg"
_disdsp:        .DEFINE "__kernel_disdsp"
_dspflg:        .DEFINE "__kernel_dspflg"
_ready_queue:   .DEFINE "__kernel_ready_queue"
_ready_primap:  .DEFINE "__kernel_ready_primap"
_initialize_task: .DEFINE "__kernel_initialize_task"
_search_schedtsk: .DEFINE "__kernel_search_schedtsk"
_make_runnable: .DEFINE "__kernel_make_runnable"
_make_non_runnable: .DEFINE "__kernel_make_non_runnable"
_make_dormant: .DEFINE "__kernel_make_dormant"
_make_active: .DEFINE "__kernel_make_active"
_change_priority: .DEFINE "__kernel_change_priority"
_rotate_ready_queue: .DEFINE "__kernel_rotate_ready_queue"
_call_texrtn_stask: .DEFINE "__kernel_call_texrtn_stask"
_calltex_stask: .DEFINE "__kernel_calltex_stask"

;
;  memory.c
;
_initialize_memory: .DEFINE "__kernel_initialize_memory"
_search_meminib: .DEFINE "__kernel_search_meminib"
_probe_mem_write: .DEFINE "__kernel_probe_mem_write"
_probe_mem_read: .DEFINE "__kernel_probe_mem_read"
_probe_stack: .DEFINE "__kernel_probe_stack"
_initialize_sections: .DEFINE "__kernel_initialize_sections"

;
;  wait.c
;
_make_wait_tmout: .DEFINE "__kernel_make_wait_tmout"
_wait_complete: .DEFINE "__kernel_wait_complete"
_wait_tmout: .DEFINE "__kernel_wait_tmout"
_wait_tmout_ok: .DEFINE "__kernel_wait_tmout_ok"
_wait_release: .DEFINE "__kernel_wait_release"
_wobj_make_wait: .DEFINE "__kernel_wobj_make_wait"
_wobj_make_wait_tmout: .DEFINE "__kernel_wobj_make_wait_tmout"
_init_wait_queue: .DEFINE "__kernel_init_wait_queue"

;
;  time_event.c
;
_current_time: .DEFINE "__kernel_current_time"
_min_time: .DEFINE "__kernel_min_time"
_next_time: .DEFINE "__kernel_next_time"
_next_subtime: .DEFINE "__kernel_next_subtime"
_last_index: .DEFINE "__kernel_last_index"
_initialize_tmevt: .DEFINE "__kernel_initialize_tmevt"
_tmevt_up: .DEFINE "__kernel_tmevt_up"
_tmevt_down: .DEFINE "__kernel_tmevt_down"
_tmevtb_insert: .DEFINE "__kernel_tmevtb_insert"
_tmevtb_delete: .DEFINE "__kernel_tmevtb_delete"
_tmevt_lefttim: .DEFINE "__kernel_tmevt_lefttim"
_signal_time: .DEFINE "__kernel_signal_time"

;
;  semaphore.c
;
_initialize_semaphore: .DEFINE "__kernel_initialize_semaphore"

;
;  eventflag.c
;
_initialize_eventflag: .DEFINE "__kernel_initialize_eventflag"
_check_flg_cond: .DEFINE "__kernel_check_flg_cond"

;
;  dataqueue.c
;
_initialize_dataqueue: .DEFINE "__kernel_initialize_dataqueue"
_enqueue_data: .DEFINE "__kernel_enqueue_data"
_force_enqueue_data: .DEFINE "__kernel_force_enqueue_data"
_dequeue_data: .DEFINE "__kernel_dequeue_data"
_send_data: .DEFINE "__kernel_send_data"
_force_send_data: .DEFINE "__kernel_force_send_data"
_receive_data: .DEFINE "__kernel_receive_data"

;
;  pridataq.c
;
_initialize_pridataq: .DEFINE "__kernel_initialize_pridataq"
_enqueue_pridata: .DEFINE "__kernel_enqueue_pridata"
_dequeue_pridata: .DEFINE "__kernel_dequeue_pridata"
_send_pridata: .DEFINE "__kernel_send_pridata"
_receive_pridata: .DEFINE "__kernel_receive_pridata"

;
;  mempfix.c
;
_initialize_mempfix: .DEFINE "__kernel_initialize_mempfix"
_get_mpf_block: .DEFINE "__kernel_get_mpf_block"

;
;  cyclic.c
;
_initialize_cyclic: .DEFINE "__kernel_initialize_cyclic"
_call_cychdr: .DEFINE "__kernel_call_cychdr"

;
;  alarm.c
;
_initialize_alarm: .DEFINE "__kernel_initialize_alarm"
_call_almhdr: .DEFINE "__kernel_call_almhdr"

;
;  overrun.c
;
_initialize_overrun: .DEFINE "__kernel_initialize_overrun"
_ovrtimer_start: .DEFINE "__kernel_ovrtimer_start"
_ovrtimer_stop: .DEFINE "__kernel_ovrtimer_stop"
_call_ovrhdr: .DEFINE "__kernel_call_ovrhdr"

;
;  interrupt.c
;
_initialize_interrupt: .DEFINE "__kernel_initialize_interrupt"

;
;  exception.c
;
_initialize_exception: .DEFINE "__kernel_initialize_exception"

;
;  svc_table.c
;
_svc_table: .DEFINE "__kernel_svc_table"

;
;  kernel_cfg.c
;
_initialize_object: .DEFINE "__kernel_initialize_object"
_call_inirtn: .DEFINE "__kernel_call_inirtn"
_call_terrtn: .DEFINE "__kernel_call_terrtn"
_tmax_domid: .DEFINE "__kernel_tmax_domid"
_dominib_table: .DEFINE "__kernel_dominib_table"
_dominib_kernel: .DEFINE "__kernel_dominib_kernel"
_tmax_tskid: .DEFINE "__kernel_tmax_tskid"
_tinib_table: .DEFINE "__kernel_tinib_table"
_torder_table: .DEFINE "__kernel_torder_table"
_tcb_table: .DEFINE "__kernel_tcb_table"
_tmax_semid: .DEFINE "__kernel_tmax_semid"
_seminib_table: .DEFINE "__kernel_seminib_table"
_semcb_table: .DEFINE "__kernel_semcb_table"
_tmax_flgid: .DEFINE "__kernel_tmax_flgid"
_flginib_table: .DEFINE "__kernel_flginib_table"
_flgcb_table: .DEFINE "__kernel_flgcb_table"
_tmax_dtqid: .DEFINE "__kernel_tmax_dtqid"
_dtqcb_table: .DEFINE "__kernel_dtqcb_table"
_dtqinib_table: .DEFINE "__kernel_dtqinib_table"
_tmax_pdqid: .DEFINE "__kernel_tmax_pdqid"
_pdqcb_table: .DEFINE "__kernel_pdqcb_table"
_pdqinib_table: .DEFINE "__kernel_pdqinib_table"
_tmax_mpfid: .DEFINE "__kernel_tmax_mpfid"
_mpfinib_table: .DEFINE "__kernel_mpfinib_table"
_mpfcb_table: .DEFINE "__kernel_mpfcb_table"
_tmax_cycid: .DEFINE "__kernel_tmax_cycid"
_cycinib_table: .DEFINE "__kernel_cycinib_table"
_cyccb_table: .DEFINE "__kernel_cyccb_table"
_tmax_almid: .DEFINE "__kernel_tmax_almid"
_alminib_table: .DEFINE "__kernel_alminib_table"
_almcb_table: .DEFINE "__kernel_almcb_table"
_ovrinib: .DEFINE "__kernel_ovrinib"
_sysstat_acvct: .DEFINE "__kernel_sysstat_acvct"
_tnum_meminib: .DEFINE "__kernel_tnum_meminib"
_memtop_table: .DEFINE "__kernel_memtop_table"
_meminib_table: .DEFINE "__kernel_meminib_table"
_tnum_meminfo: .DEFINE "__kernel_tnum_meminfo"
_meminfo_table: .DEFINE "__kernel_meminfo_table"
_tnum_inhno: .DEFINE "__kernel_tnum_inhno"
_inhinib_table: .DEFINE "__kernel_inhinib_table"
_tnum_intno: .DEFINE "__kernel_tnum_intno"
_intinib_table: .DEFINE "__kernel_intinib_table"
_tnum_excno: .DEFINE "__kernel_tnum_excno"
_excinib_table: .DEFINE "__kernel_excinib_table"
_tmax_fncd: .DEFINE "__kernel_tmax_fncd"
_svcinib_table: .DEFINE "__kernel_svcinib_table"
_tmevt_heap: .DEFINE "__kernel_tmevt_heap"
_istksz: .DEFINE "__kernel_istksz"
_istk: .DEFINE "__kernel_istk"
_istkpt: .DEFINE "__kernel_istkpt"
_tnum_datasec: .DEFINE "__kernel_tnum_datasec"
_datasecinib_table: .DEFINE "__kernel_datasecinib_table"
_tnum_bsssec: .DEFINE "__kernel_tnum_bsssec"
_bsssecinib_table: .DEFINE "__kernel_bsssecinib_table"

    .INCLUDE "target_rename.inc"
