/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2008-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  $Id: domain.h 263 2010-02-14 05:32:25Z ertl-hiro $
 */

/*
 *		یhCǗW[
 */

#ifndef TOPPERS_DOMAIN_H
#define TOPPERS_DOMAIN_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  یhCubN
 */
typedef struct domain_initialization_block {
	ACPTN		domptn;			/* یhC̃rbgp^[ */
#ifdef USE_DOMINICTXB
	DOMINICTXB	domctxb;		/* یhCReLXgubN */
#endif /* USE_DOMINICTXB */
} DOMINIB;

/*
 *  یhCID̍őlikernel_cfg.cj
 */
extern const ID	tmax_domid;

/*
 *  یhCubÑGAikernel_cfg.cj
 */
extern const DOMINIB	dominib_table[];

/*
 *  J[lhC̕یhCubNikernel_cfg.cj
 */
extern const DOMINIB	dominib_kernel;

/*
 *  یhCIDیhCubNo߂̃}N
 */
#define INDEX_DOM(domid)	((uint_t)((domid) - TMIN_DOMID))
#define get_dominib(domid)	(&(dominib_table[INDEX_DOM(domid)]))

/*
 *  یhCubNیhCIDo߂̃}N
 */
#define	DOMID(p_dominib)	(((p_dominib) == &dominib_kernel) ? TDOM_KERNEL \
							: (ID)(((p_dominib) - dominib_table) + TMIN_DOMID))

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_DOMAIN_H_ */
