$ ======================================================================
$
$   TOPPERS/HRP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       High Reliable system Profile Kernel
$
$   Copyright (C) 2007 by TAKAGI Nobuhisa
$   Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$  
$   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
$   Ai{\tgEFAς̂܂ށDȉjgpEE
$   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
$   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
$       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
$       XR[hɊ܂܂Ă邱ƁD
$   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
$       pł`ōĔzzꍇɂ́CĔzzɔhLgip
$       ҃}jAȂǁjɁCL̒쌠\C̗pщL
$       ̖ۏ؋Kfڂ邱ƁD
$   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
$       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
$       ƁD
$     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
$         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
$     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
$         񍐂邱ƁD
$   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
$       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
$       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
$       RɊÂCL쌠҂TOPPERSvWFNg
$       Ɛӂ邱ƁD
$  
$   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
$   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
$   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
$   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
$   ̐ӔC𕉂ȂD
$
$   $Id: kernel.tf 624 2012-05-16 02:22:59Z ertl-hiro $
$
$ =====================================================================

$ =====================================================================
$ kernel_cfg.h̐
$ =====================================================================

$ gT[rXR[ԍ̍őltmax_fncdɋ߂
$tmax_fncd = 0$
$FOREACH order SVC.ORDER_LIST$
	$IF SVC.FNCD[order] > tmax_fncd$
		$tmax_fncd = SVC.FNCD[order]$
	$END$
$END$

$FILE "kernel_cfg.h"$
/* kernel_cfg.h */$NL$
#ifndef TOPPERS_KERNEL_CFG_H$NL$
#define TOPPERS_KERNEL_CFG_H$NL$
$NL$
#define TNUM_DOMID	$LENGTH(DOM.ID_LIST)$$NL$
#define TNUM_TSKID	$LENGTH(TSK.ID_LIST)$$NL$
#define TNUM_SEMID	$LENGTH(SEM.ID_LIST)$$NL$
#define TNUM_FLGID	$LENGTH(FLG.ID_LIST)$$NL$
#define TNUM_DTQID	$LENGTH(DTQ.ID_LIST)$$NL$
#define TNUM_PDQID	$LENGTH(PDQ.ID_LIST)$$NL$
#define TNUM_MTXID	$LENGTH(MTX.ID_LIST)$$NL$
#define TNUM_MPFID	$LENGTH(MPF.ID_LIST)$$NL$
#define TNUM_CYCID	$LENGTH(CYC.ID_LIST)$$NL$
#define TNUM_ALMID	$LENGTH(ALM.ID_LIST)$$NL$
$NL$
#define TMAX_FNCD	$tmax_fncd$$NL$
$NL$
$FOREACH id DOM.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$FOREACH id TSK.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$FOREACH id SEM.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$FOREACH id FLG.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$FOREACH id DTQ.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$FOREACH id PDQ.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$FOREACH id MTX.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$FOREACH id MPF.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$FOREACH id CYC.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$FOREACH id ALM.ID_LIST$
	#define $id$	$+id$$NL$
$END$
$NL$
#endif /* TOPPERS_KERNEL_CFG_H */$NL$

$ =====================================================================
$ یhCɊւO
$ =====================================================================

$
$  یhCXg̍쐬
$	DOMLISTF[UhC̃Xg
$	DOMLIST_ALLFJ[lhCC[UhCC̃Xg
$
$FOREACH domid DOM.ID_LIST$
	$DOMLIST = APPEND(DOMLIST, domid)$
$END$
$DOMLIST_ALL = APPEND(TDOM_KERNEL, DOMLIST, TDOM_NONE)$

$
$  یhC̃ftHg̃ANZXp^[̍쐬
$
$DEFAULT_ACPTN[TDOM_KERNEL] = VALUE("TACP_KERNEL", TACP_KERNEL)$
$FOREACH domid DOM.ID_LIST$
	$DEFAULT_ACPTN[domid] = VALUE(FORMAT("TACP(%1%)", domid), 1 << (domid - 1))$
$END$
$DEFAULT_ACPTN[TDOM_NONE] = VALUE("TACP_SHARED", TACP_SHARED)$

$
$  یhC̃ftHg̃ANZXxN^ij̍쐬
$
$FOREACH domid DOMLIST_ALL$
	$DEFAULT_ACVCT[domid] = FORMAT(" { %1%, %1%, %1%, %1% }",
											DEFAULT_ACPTN[domid])$
$END$

$
$  یhC̃x̍쐬
$	DOM.LABEL[domid]FیhC̃x
$
$DOM.LABEL[TDOM_KERNEL] = "kernel"$
$FOREACH domid DOM.ID_LIST$
	$DOM.LABEL[domid] = domid$
$END$
$DOM.LABEL[TDOM_NONE] = "shared"$

$ =====================================================================
$ IuWFNgɊւO
$
$ ÕIuWFNg̏MO.XXXX[moid]ɐD
$
$ nummoFÕIuWFNg̐
$ MO.TYPE[moid]FIuWFNg̃^Cv
$	TOPPERS_ATTMODFATT_MOD^ATA_MODœo^ꂽZNV
$					W[MO.MODULE[moid]ɐݒ
$	TOPPERS_ATTSECFATT_SEC^ATA_SECœo^ꂽZNV
$	TOPPERS_ATTMEMFATT_MEM^ATA_MEM^ATT_PMA^ATA_PMAœo^ꂽZNV
$					擪ԒnMO.BASE[moid]ɐݒ
$					TCYMO.SIZE[moid]ɐݒ
$					AhXMO.PADDR[moid]ɐݒiATT_PMA^ATA_PMA̎j
$	TOPPERS_USTACKF^XÑ[UX^bN̈ibh][̏ꍇ̃_
$					~[X^bN̈̃^Cvj
$					^XNIDMO.TSKID[moid]ɐݒi_~[X^bN̈̏
$					0j
$					擪ԒnMO.BASE[moid]ɐݒi[UX^bN̈A
$					vP[Vw肵ꍇ̂݁j
$					TCYMO.SIZE[moid]ɐݒ
$	TOPPERS_MPFAREAFŒ蒷v[̈iRtBM[^t
$					 ꍇ̂݁j
$					 Œ蒷v[IDMO.MPFID[moid]ɐݒ
$ MO.LINKER[moid]FJzu郁IuWFNgH
$ MO.DOMAIN[moid]FhCȉꍇTDOM_NONEj
$ MO.MEMREG[moid]F[WԍiJzuꍇ̂݁j
$ MO.SECTION[moid]FZNViJzuꍇ̂݁j
$ MO.MEMATR[moid]FIuWFNg
$ MO.ACPTN1[moid]Fʏ푀1i݁j̃ANZXp^[
$ MO.ACPTN2[moid]Fʏ푀2iǏoCsj̃ANZXp^[
$ MO.ACPTN4[moid]FQƑ̃ANZXp^[
$ MO.TEXT_LINE[moid]FIuWFNgo^ÓIAPI̍sԍ
$ MO_USTACK_LISTFRtBM[^t郆[UX^bN̈̃Xg
$ =====================================================================

$TOPPERS_ATTMOD = TOPPERS_ATTSEC + 1$
$TOPPERS_MPFAREA = TOPPERS_ATTSEC + 2$
$nummo = 0$
$MO_USTACK_LIST = {}$

$
$  zuZNVɊւO
$
$ LNK_SECŔzuZNViIuWFNgƂēo^Ȃj̏
$ CLNKSEC[lsid]ɐD
$
$ numlsFzuZNV̐
$ LNKSEC.MEMREG[lsid]F[Wԍ
$ LNKSEC.SECTION[lsid]FZNV

$numls = 0$

$
$  ATT_REGœo^ꂽ[WɊւG[`FbNƑO
$
$ REG_LISTFς݂̃[W̃Xg
$ REG.REGNAME[reg]F[WiUNESCSTR(MO.REGION[reg])j
$ STANDARD_ROMFWROM[W̃[Wԍ
$ STANDARD_RAMFWRAM[W̃[Wԍ
$
$FOREACH reg REG.ORDER_LIST$
$	// REG.REGNAME[reg]̍쐬
	$REG.REGNAME[reg] = UNESCSTR(REG.REGION[reg])$

$	// [Wo^ς݂̏ꍇiE_OBJj
	$FOREACH reg2 REG_LIST$
		$IF EQ(REG.REGNAME[reg], REG.REGNAME[reg2])$
			$ERROR REG.TEXT_LINE[reg]$E_OBJ: $FORMAT(_("%1% `%2%\' in %3% is duplicated"), "memory region", REG.REGNAME[reg], "ATT_REG")$$END$
		$END$
	$END$

$	// regatrimTA_NOWRITE|TA_STDROM|TA_STDRAMnjłȂꍇiE_RSATRj
$	// regatrTA_STDROMTA_STDRAM̗w肵ꍇiTA_RSATRj
	$IF (REG.REGATR[reg] & ~(TA_NOWRITE|TA_STDROM|TA_STDRAM|TARGET_REGATR)) != 0
		|| (REG.REGATR[reg] & (TA_STDROM|TA_STDRAM)) == (TA_STDROM|TA_STDRAM)$
		$ERROR REG.TEXT_LINE[reg]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "regatr", REG.REGATR[reg], "ATT_REG")$$END$
	$END$

$	// یhCɏĂꍇiE_RSATRj
	$IF LENGTH(REG.DOMAIN[reg])$
		$ERROR REG.TEXT_LINE[reg]$E_RSATR: $FORMAT(_("%1% `%2%\' belongs to a protection domain in %3%"), "memory region", REG.REGNAME[reg], "ATT_REG")$$END$
	$END$

$	// size0̏ꍇ
	$IF REG.SIZE[reg] == 0$
		$ERROR REG.TEXT_LINE[reg]$E_PAR: $FORMAT(_("%1% `%2%\' is zero in %3%"), "size", REG.SIZE[reg], "ATT_REG")$$END$
	$END$

$	// base+sizeőAhXzꍇ
	$limit = (REG.BASE[reg] + REG.SIZE[reg]) & ((1 << sizeof_void_ptr * 8) - 1)$
	$IF limit < REG.BASE[reg] && limit != 0$
		$ERROR REG.TEXT_LINE[reg]$E_PAR: $FORMAT(_("%1% `%2%\' is too large in %3%"), "size", REG.SIZE[reg], "ATT_REG")$$END$
	$END$

$	// o^ς݂̃[WƗ̈悪dȂꍇiE_OBJj
	$FOREACH reg2 REG_LIST$
		$IF ((REG.BASE[reg] <= REG.BASE[reg2]
						&& REG.BASE[reg] + REG.SIZE[reg] > REG.BASE[reg2])
		  || (REG.BASE[reg2] < REG.BASE[reg]
						&& REG.BASE[reg2] + REG.SIZE[reg2] > REG.BASE[reg]))$
			$ERROR REG.TEXT_LINE[reg]$E_OBJ: $FORMAT(_("%1% `%2%\' overlaps with another %1% `%3%\'"), "memory region", REG.REGNAME[reg], REG.REGNAME[reg2])$$END$
		$END$
	$END$

$	// STANDARD_ROMSTANDARD_RAM߂
	$IF (REG.REGATR[reg] & TA_STDROM) != 0$
		$REG.REGATR[reg] = REG.REGATR[reg] | TA_NOWRITE$
$		// TA_STDROM̃[Wo^ꂽꍇiE_OBJj
		$IF LENGTH(STANDARD_ROM)$
			$ERROR REG.TEXT_LINE[reg]$E_OBJ: $FORMAT(_("more than one %1% with `%2%\' in %3%"), "memory region", "TA_STDROM", "ATT_REG")$$END$
		$END$
		$STANDARD_ROM = reg$
	$END$
	$IF (REG.REGATR[reg] & TA_STDRAM) != 0$
$		// TA_STDRAM̃[Wo^ꂽꍇiE_OBJj
		$IF LENGTH(STANDARD_RAM)$
			$ERROR REG.TEXT_LINE[reg]$E_OBJ: $FORMAT(_("more than one %1% with `%2%\' in %3%"), "memory region", "TA_STDRAM", "ATT_REG")$$END$
		$END$
		$STANDARD_RAM = reg$
	$END$

$	// ^[Qbgˑ̃G[`FbN
	$IF ISFUNCTION("HOOK_ERRORCHECK_REG")$
		$HOOK_ERRORCHECK_REG(reg)$
	$END$
	$REG_LIST = APPEND(REG_LIST, reg)$
$END$

$ WROM/RAM[Wo^̃G[̌o
$IF TOPPERS_SUPPORT_ATT_MOD$
$	// TA_STDROM̃[Wo^iE_OBJj
	$IF !LENGTH(STANDARD_ROM)$
		$ERROR$E_OBJ: $FORMAT(_("no %1% with `%2%\' is registered"),
										"memory region", "TA_STDROM")$$END$
	$END$

$	// TA_STDRAM̃[Wo^iE_OBJj
	$IF !LENGTH(STANDARD_RAM)$
		$ERROR$E_OBJ: $FORMAT(_("no %1% with `%2%\' is registered"),
										"memory region", "TA_STDRAM")$$END$
	$END$

$	// ǂ炩o^̏ꍇ́Cŏ~߂iȍ~̃G[̗}~j
	$IF !LENGTH(STANDARD_ROM) || !LENGTH(STANDARD_RAM)$
		$DIE()$
	$END$
$END$

$ REG_ORDER̐
$REG_ORDER = SORT(REG.ORDER_LIST, "REG.BASE")$

$
$  W̃ZNV̒`ƕWZNṼXg̍쐬
$
$ DSEC_SECTION_LISTFW̃ZNVƕیhCWZNṼXg
$
$DEFINE_DSEC()$

$FOREACH dsec DSEC.ORDER_LIST$
	$DSEC_SECTION_LIST = APPEND(DSEC_SECTION_LIST, DSEC.SECTION[dsec])$
$END$
$FOREACH domid DOMLIST_ALL$
	$FOREACH dsec DSEC.ORDER_LIST$
		$DSEC_SECTION_LIST = APPEND(DSEC_SECTION_LIST,
					FORMAT("%s_%s", DSEC.SECTION[dsec], DOM.LABEL[domid]))$
	$END$
$END$

$
$  ATT_MOD̂ƓɈW[̏
$
$ 擪ATT_MOD̂ƓFSTART_OBJS, libkernel.o, kernel_mem.o, libkernel.a
$ ATT_MOD̂ƓF*, END_OBJS
$
$IF TOPPERS_SUPPORT_ATT_MOD$
	$nummod = LENGTH(MOD.ORDER_LIST)$

	$FUNCTION ATT_MOD_FIRST$
		$nummod = nummod + 1$
		$MOD.ORDER_LIST = APPEND(nummod, MOD.ORDER_LIST)$
		$MOD.MODULE[nummod] = ESCSTR(ARGV[1])$
		$MOD.DOMAIN[nummod] = ARGV[2]$
		$MOD.TEXT_LINE[nummod] = 0$
	$END$
 
	$FUNCTION ATT_MOD_LAST$
		$nummod = nummod + 1$
		$MOD.ORDER_LIST = APPEND(MOD.ORDER_LIST, nummod)$
		$MOD.MODULE[nummod] = ESCSTR(ARGV[1])$
		$MOD.DOMAIN[nummod] = ARGV[2]$
		$MOD.TEXT_LINE[nummod] = 0$
	$END$

	$FOREACH module APPEND("libkernel.a", "kernel_mem.o", "kernel_cfg.o",
															START_OBJS)$
		$ATT_MOD_FIRST(module, TDOM_KERNEL)$
	$END$

	$ATT_MOD_LAST("*", TDOM_NONE)$
	$FOREACH module END_OBJS$
		$ATT_MOD_LAST(module, TDOM_KERNEL)$
	$END$
$END$

$
$  ATT_MOD^ATA_MODœo^ꂽW[Ɋւ̐
$
$ MOD_LISTFς݂̃W[̃Xg
$
$FOREACH mod MOD.ORDER_LIST$
$	// ATT_MOD/ATA_MODT|[gĂȂꍇiE_NOSPTj
	$IF !TOPPERS_SUPPORT_ATT_MOD$
		$ERROR MOD.TEXT_LINE[mod]$E_NOSPT: $FORMAT(_("%1% is not supported on this target"), "ATT_MOD/ATA_MOD")$$END$
	$END$

$	// moduleo^ς݂̏ꍇiE_OBJj
	$FOREACH mod2 MOD_LIST$
		$IF EQ(MOD.MODULE[mod], MOD.MODULE[mod2])$
			$ERROR MOD.TEXT_LINE[mod]$E_OBJ: $FORMAT(_("%1% `%2%\' in %3% is duplicated"), "module", UNESCSTR(MOD.MODULE[mod]), "ATT_MOD/ATA_MOD")$$END$
		$END$
	$END$

$	// ^[Qbgˑ̃G[`FbN
	$IF ISFUNCTION("HOOK_ERRORCHECK_MOD")$
		$HOOK_ERRORCHECK_MOD(mod)$
	$END$

$	// IuWFNg̐
	$FOREACH dsec DSEC.ORDER_LIST$
		$nummo = nummo + 1$
		$MO.TYPE[nummo] = TOPPERS_ATTMOD$
		$MO.MODULE[nummo] = UNESCSTR(MOD.MODULE[mod])$
		$MO.LINKER[nummo] = 1$
		$IF EQ(MOD.DOMAIN[mod], "")$
			$MO.DOMAIN[nummo] = TDOM_NONE$
		$ELSE$
			$MO.DOMAIN[nummo] = MOD.DOMAIN[mod]$
		$END$
		$MO.MEMREG[nummo] = DSEC.MEMREG[dsec]$
		$MO.SECTION[nummo] = DSEC.SECTION[dsec]$
		$MO.MEMATR[nummo] = DSEC.MEMATR[dsec]$

		$domptn = DEFAULT_ACPTN[MO.DOMAIN[nummo]]$
		$MO.ACPTN1[nummo] = ALT(MOD.ACPTN1[mod], domptn)$
		$MO.ACPTN2[nummo] = ALT(MOD.ACPTN2[mod], domptn)$
		$MO.ACPTN4[nummo] = ALT(MOD.ACPTN4[mod], domptn)$
		$MO.TEXT_LINE[nummo] = MOD.TEXT_LINE[mod]$
	$END$
	$MOD_LIST = APPEND(MOD_LIST, mod)$
$END$

$
$  ATT_SEC^ATA_SEC^LNK_SECœo^ꂽZNVɊւ̐
$
$ SEC_LISTFς݂̃ZNṼXg
$
$FOREACH sec SEC.ORDER_LIST$
$	// sectionW̃ZNV̏ꍇiE_PARj
	$IF TOPPERS_SUPPORT_ATT_MOD || !LENGTH(SEC.MEMATR[sec])$
		$IF LENGTH(FIND(DSEC_SECTION_LIST, UNESCSTR(SEC.SECTION[sec])))$
			$ERROR SEC.TEXT_LINE[sec]$E_PAR: 
				$FORMAT(_("default section `%1%\' cannot be attached with %2%"), UNESCSTR(SEC.SECTION[sec]), "ATT_SEC/ATA_SEC/LNK_SEC")$
			$END$
		$END$
	$END$

$	// sectiono^ς݂̏ꍇiE_OBJj
	$FOREACH sec2 SEC_LIST$
		$IF EQ(SEC.SECTION[sec], SEC.SECTION[sec2])$
			$ERROR SEC.TEXT_LINE[sec]$E_OBJ: 
				$FORMAT(_("%1% `%2%\' in %3% is duplicated"), "section", UNESCSTR(SEC.SECTION[sec]), "ATT_SEC/ATA_SEC/LNK_SEC")$
			$END$
		$END$
	$END$

$	// memreg̃`FbN
	$memreg = 0$
	$FOREACH reg REG.ORDER_LIST$
		$IF EQ(UNESCSTR(SEC.MEMREG[sec]), REG.REGNAME[reg])$
			$memreg = reg$
		$END$
	$END$
	$IF memreg == 0$
		$ERROR SEC.TEXT_LINE[sec]$E_PAR: 
			$FORMAT(_("illegal %1% `%2%\' in %3%"), "region name", UNESCSTR(SEC.MEMREG[sec]), "ATT_SEC/ATA_SEC/LNK_SEC")$
		$END$
$		// ȍ~̃G[̗}~
		$memreg = STANDARD_RAM$
	$END$

	$IF LENGTH(SEC.MEMATR[sec])$
$		// ATT_SEC^ATA_SEC̏ꍇ

$		// mematrimTA_NOWRITE|TA_NOREAD|TA_EXEC|TA_MEMINI|TA_MEMPRSV|TA_SDATA|TA_UNCACHE|TA_IODEVnjłȂꍇiE_RSATRj
$		// mematrTA_MEMINITA_MEMPRSV̗w肵ꍇiTA_RSATRj
		$IF (SEC.MEMATR[sec] & ~(TA_NOWRITE|TA_NOREAD|TA_EXEC|TA_MEMINI|TA_MEMPRSV|TA_SDATA|TA_UNCACHE|TA_IODEV|TARGET_MEMATR)) != 0
			|| (SEC.MEMATR[sec] & (TA_MEMINI|TA_MEMPRSV)) == (TA_MEMINI|TA_MEMPRSV)$
			$ERROR SEC.TEXT_LINE[sec]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "mematr", SEC.MEMATR[sec], "ATT_SEC/ATA_SEC")$$END$
		$END$

$		// ^[Qbgˑ̃G[`FbN
		$IF ISFUNCTION("HOOK_ERRORCHECK_SEC")$
			$HOOK_ERRORCHECK_SEC(sec)$
		$END$

$		// IuWFNg̐
		$nummo = nummo + 1$
		$MO.TYPE[nummo] = TOPPERS_ATTSEC$
		$MO.LINKER[nummo] = 1$
		$IF EQ(SEC.DOMAIN[sec], "")$
			$MO.DOMAIN[nummo] = TDOM_NONE$
		$ELSE$
			$MO.DOMAIN[nummo] = SEC.DOMAIN[sec]$
		$END$
		$MO.MEMREG[nummo] = memreg$
		$MO.SECTION[nummo] = UNESCSTR(SEC.SECTION[sec])$
		$IF (REG.REGATR[memreg] & TA_NOWRITE) != 0$
$			// [WTA_NOWRITEݒ肳Ă鎞́C
$			// IuWFNgTA_NOWRITEݒ肷D
			$MO.MEMATR[nummo] = SEC.MEMATR[sec] | TA_NOWRITE$
		$ELSE$
			$MO.MEMATR[nummo] = SEC.MEMATR[sec]$
		$END$

		$domptn = DEFAULT_ACPTN[MO.DOMAIN[nummo]]$
		$MO.ACPTN1[nummo] = ALT(SEC.ACPTN1[sec], domptn)$
		$MO.ACPTN2[nummo] = ALT(SEC.ACPTN2[sec], domptn)$
		$MO.ACPTN4[nummo] = ALT(SEC.ACPTN4[sec], domptn)$
		$MO.TEXT_LINE[nummo] = SEC.TEXT_LINE[sec]$
	$ELSE$
$		// LNK_SEC̏ꍇ

$		// zuZNV̐
		$numls = numls + 1$
		$LNKSEC.MEMREG[numls] = memreg$
		$LNKSEC.SECTION[numls] = UNESCSTR(SEC.SECTION[sec])$
	$END$
	$SEC_LIST = APPEND(SEC_LIST, sec)$
$END$

$
$  یhC̕WZNVɊւ̐
$
$FOREACH domid DOMLIST_ALL$
	$FOREACH dsec DSEC.ORDER_LIST$
$		// IuWFNg̐
		$nummo = nummo + 1$
		$MO.TYPE[nummo] = TOPPERS_ATTSEC$
		$MO.LINKER[nummo] = 1$
		$MO.DOMAIN[nummo] = domid$
		$MO.MEMREG[nummo] = DSEC.MEMREG[dsec]$
		$MO.SECTION[nummo] = FORMAT("%s_%s", DSEC.SECTION[dsec], DOM.LABEL[domid])$
		$MO.MEMATR[nummo] = DSEC.MEMATR[dsec]$

		$domptn = DEFAULT_ACPTN[domid]$
		$MO.ACPTN1[nummo] = domptn$
		$MO.ACPTN2[nummo] = domptn$
		$MO.ACPTN4[nummo] = domptn$
	$END$
$END$

$
$  ATT_MEM^ATA_MEM^ATT_PMA^ATA_PMAœo^ꂽZNVɊւ̐
$
$FOREACH mem MEM.ORDER_LIST$
$	// ATT_MEM^ATA_MEMATT_PMA^ATA_PMA̔
	$IF !LENGTH(MEM.PADDR[mem])$
		$apiname = "ATT_MEM/ATA_MEM"$
	$ELSE$
		$apiname = "ATT_PMA/ATA_PMA"$
$		// ATT_PMA^ATA_PMAgpꍇ̃G[`FbNiE_NOSPTj
		$IF !TOPPERS_SUPPORT_ATT_PMA$
			$ERROR MEM.TEXT_LINE[mem]$E_NOSPT: $FORMAT(_("%1% is not supported on this target"), apiname)$$END$
		$END$
	$END$

$	// mematrimTA_NOWRITE|TA_NOREAD|TA_EXEC|TA_MEMINI|TA_MEMPRSV|TA_SDATA|TA_UNCACHE|TA_IODEVnjłȂꍇiE_RSATRj
$	// mematrTA_MEMPRSVw肵ȂTA_MEMINIw肵ꍇiTA_RSATRj
	$IF (MEM.MEMATR[mem] & ~(TA_NOWRITE|TA_NOREAD|TA_EXEC|TA_MEMINI|TA_MEMPRSV|TA_SDATA|TA_UNCACHE|TA_IODEV|TARGET_MEMATR)) != 0
		|| (MEM.MEMATR[mem] & (TA_MEMINI|TA_MEMPRSV)) != TA_MEMPRSV$
		$ERROR MEM.TEXT_LINE[mem]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "mematr", MEM.MEMATR[mem], apiname)$$END$
	$END$

$	// size0̏ꍇ
	$IF MEM.SIZE[mem] == 0$
		$ERROR MEM.TEXT_LINE[mem]$E_PAR: $FORMAT(_("%1% `%2%\' is zero in %3%"), "size", MEM.SIZE[mem], apiname)$$END$
	$END$

$	// ^[Qbgˑ̃G[`FbN
	$IF ISFUNCTION("HOOK_ERRORCHECK_MEM")$
		$HOOK_ERRORCHECK_MEM(mem)$
	$END$

$	// IuWFNg̐
	$nummo = nummo + 1$
	$MO.TYPE[nummo] = TOPPERS_ATTMEM$
	$MO.BASE[nummo] = MEM.BASE[mem]$
	$MO.SIZE[nummo] = MEM.SIZE[mem]$
	$MO.PADDR[nummo] = MEM.PADDR[mem]$
	$MO.LINKER[nummo] = 0$
	$IF EQ(MEM.DOMAIN[mem], "")$
		$MO.DOMAIN[nummo] = TDOM_NONE$
	$ELSE$
		$MO.DOMAIN[nummo] = MEM.DOMAIN[mem]$
	$END$
	$MO.MEMATR[nummo] = MEM.MEMATR[mem]$

	$domptn = DEFAULT_ACPTN[MO.DOMAIN[nummo]]$
	$MO.ACPTN1[nummo] = ALT(MEM.ACPTN1[mem], domptn)$
	$MO.ACPTN2[nummo] = ALT(MEM.ACPTN2[mem], domptn)$
	$MO.ACPTN4[nummo] = ALT(MEM.ACPTN4[mem], domptn)$
	$MO.TEXT_LINE[nummo] = MEM.TEXT_LINE[mem]$
$END$

$ =====================================================================
$ kernel_mem2.c̋ʕ̐
$ =====================================================================

$FILE "kernel_mem2.c"$
/* kernel_mem2.c */$NL$
#include "kernel/kernel_int.h"$NL$
#include "kernel_cfg.h"$NL$
$NL$
#if TKERNEL_PRID != 0x06u$NL$
#error "The kernel does not match this configuration file."$NL$
#endif$NL$
$NL$

/*$NL$
$SPC$*  Include Directives (#include)$NL$
$SPC$*/$NL$
$NL$
$INCLUDES$
$NL$

$ =====================================================================
$ kernel_cfg.c̐
$ =====================================================================

$FILE "kernel_cfg.c"$
/* kernel_cfg.c */$NL$
#include "kernel/kernel_int.h"$NL$
#include "kernel_cfg.h"$NL$
$NL$
#ifndef TOPPERS_EMPTY_LABEL$NL$
#define TOPPERS_EMPTY_LABEL(x,y) x y[0]$NL$
#endif$NL$
$NL$
#if TKERNEL_PRID != 0x06u$NL$
#error "The kernel does not match this configuration file."$NL$
#endif$NL$
$NL$

$
$  CN[hfBNeBui#includej
$
/*$NL$
$SPC$*  Include Directives (#include)$NL$
$SPC$*/$NL$
$NL$
$INCLUDES$
$NL$

$
$  IuWFNgIDԍێϐ
$
$IF USE_EXTERNAL_ID$
	/*$NL$
	$SPC$*  Variables for Object ID$NL$
	$SPC$*/$NL$
	$NL$
	$FOREACH id DOM.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
	$FOREACH id TSK.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
	$FOREACH id SEM.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
	$FOREACH id FLG.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
	$FOREACH id DTQ.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
	$FOREACH id PDQ.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
	$FOREACH id MTX.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
	$FOREACH id MPF.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
	$FOREACH id CYC.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
	$FOREACH id ALM.ID_LIST$
		const ID $id$_id$SPC$=$SPC$$+id$;$NL$
	$END$
$END$

$
$  g[XO}ÑftHg`
$
/*$NL$
$SPC$*  Default Definitions of Trace Log Macros$NL$
$SPC$*/$NL$
$NL$
#ifndef LOG_ISR_ENTER$NL$
#define LOG_ISR_ENTER(intno)$NL$
#endif /* LOG_ISR_ENTER */$NL$
$NL$
#ifndef LOG_ISR_LEAVE$NL$
#define LOG_ISR_LEAVE(intno)$NL$
#endif /* LOG_ISR_LEAVE */$NL$
$NL$

$
$  یhC
$
/*$NL$
$SPC$*  Protection Domain Management Functions$NL$
$SPC$*/$NL$
$NL$

$ یhCIDԍ̍ől
const ID _kernel_tmax_domid = (TMIN_DOMID + TNUM_DOMID - 1);$NL$
$NL$

$ یhCReLXgubN̂߂̐錾
$IF ISFUNCTION("PREPARE_DOMINICTXB")$
	$PREPARE_DOMINICTXB()$
$END$

$ J[lhC̕یhCubN
const DOMINIB _kernel_dominib_kernel = { TACP_KERNEL
$IF USE_DOMINICTXB$
	, $DOMINICTXB_KERNEL$
$END$
$SPC$};$NL$
$NL$

$ یhCubN
$IF LENGTH(DOM.ID_LIST)$
	const DOMINIB _kernel_dominib_table[TNUM_DOMID] = {$NL$
	$JOINEACH domid DOM.ID_LIST ",\n"$
		$TAB${ TACP($domid$)
		$IF USE_DOMINICTXB$
			, $GENERATE_DOMINICTXB(domid)$
		$END$
		$SPC$}
	$END$$NL$
	};$NL$
	$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const DOMINIB, _kernel_dominib_table);$NL$
$END$$NL$

$
$  VXeX^bN̈̊mۊ֐
$
$IF !ISFUNCTION("ALLOC_SSTACK")$
$FUNCTION ALLOC_SSTACK$
	static STK_T $ARGV[1]$[COUNT_STK_T($ARGV[2]$)];$NL$
$END$
$END$

$
$  ^XN
$
/*$NL$
$SPC$*  Task Management Functions$NL$
$SPC$*/$NL$
$NL$

$ ^XN1ȏ㑶݂邱Ƃ̃`FbN
$IF !LENGTH(TSK.ID_LIST)$
	$ERROR$$FORMAT(_("no task is registered"))$$END$
$END$

$ ^XNIDԍ̍ől
const ID _kernel_tmax_tskid = (TMIN_TSKID + TNUM_TSKID - 1);$NL$
$NL$

$ G[`FbN
$FOREACH tskid TSK.ID_LIST$
$	// یhCɏĂȂꍇiE_RSATRj
	$IF !LENGTH(TSK.DOMAIN[tskid])$
		$ERROR TSK.TEXT_LINE[tskid]$E_RSATR: $FORMAT(_("%1% `%2%\' must belong to a protection domain in %3%"), "task", tskid, "CRE_TSK")$$END$
$		// ȍ~̃G[̗}~
		$TSK.DOMAIN[tskid] = TDOM_KERNEL$
	$END$

$	// tskatrimTA_ACTnjłȂꍇiE_RSATRj
	$IF (TSK.TSKATR[tskid] & ~(TA_ACT|TARGET_TSKATR)) != 0$
		$ERROR TSK.TEXT_LINE[tskid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "tskatr", TSK.TSKATR[tskid], tskid, "CRE_TSK")$$END$
	$END$

$	// (TMIN_TPRI <= itskpri && itskpri <= TMAX_TPRI)łȂꍇiE_PARj
	$IF !(TMIN_TPRI <= TSK.ITSKPRI[tskid] && TSK.ITSKPRI[tskid] <= TMAX_TPRI)$
		$ERROR TSK.TEXT_LINE[tskid]$E_PAR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "itskpri", TSK.ITSKPRI[tskid], tskid, "CRE_TSK")$$END$
	$END$

$ 	// texatriTA_NULLjłȂꍇiE_RSATRj
	$IF LENGTH(TSK.TEXATR[tskid]) && TSK.TEXATR[tskid] != 0$
		$ERROR DEF_TEX.TEXT_LINE[tskid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "texatr", TSK.TEXATR[tskid], tskid, "DEF_TEX")$$END$
	$END$
$END$

$  VXeX^bNTCYC0ł邩C^[Qbg`̍ŏl
$  iTARGET_MIN_SSTKSZjꍇ̃G[`FbN֐iE_PARj
$FUNCTION CHECK_MIN_SSTKSZ$
	$IF ARGV[1] == 0 || (TARGET_MIN_SSTKSZ && ARGV[1] < TARGET_MIN_SSTKSZ)$
		$ERROR TSK.TEXT_LINE[tskid]$E_PAR: $FORMAT(_("%1% `%2%\' of `%3%\' in %4% is too small"), ARGV[2], ARGV[1], tskid, "CRE_TSK")$$END$
	$END$
$END$

$ VXeX^bN̈̐ƂɊւG[`FbN
$FOREACH tskid TSK.ID_LIST$
	$IF TSK.DOMAIN[tskid] == TDOM_KERNEL$
$		// VXe^XN̏ꍇ̏

$		// sstkȗĂ炸CNULLłȂꍇiE_PARj
		$IF LENGTH(TSK.SSTK[tskid]) && !EQ(TSK.SSTK[tskid],"NULL")$
			$ERROR TSK.TEXT_LINE[tskid]$E_PAR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "sstk", TSK.SSTK[tskid], tskid, "CRE_TSK")$$END$
		$END$

$		// stksz0̏ꍇiE_PARj
		$IF TSK.STKSZ[tskid] == 0$
			$ERROR TSK.TEXT_LINE[tskid]$E_PAR: $FORMAT(_("%1% `%2%\' of `%3%\' in %4% is zero"), "stksz", TSK.STKSZ[tskid], tskid, "CRE_TSK")$$END$
		$END$

		$IF EQ(TSK.STK[tskid],"NULL")$
$			// stkNULL̏ꍇ̏

			$IF LENGTH(TSK.SSTKSZ[tskid])$
$				// sstkszȗĂȂꍇ̏

$				// VXeX^bN̈̃TCY߂iG[`FbN
$				// g߁CG[`FbN̑Oɋ߂Ăj
				$sstksz = VALUE(FORMAT("(%1%) + (%2%)",
									TSK.STKSZ[tskid], TSK.SSTKSZ[tskid]),
								TSK.STKSZ[tskid]+TSK.SSTKSZ[tskid])$

$				// stksz+sstksz^[Qbg`̍ŏlꍇiE_PARj
				$CHECK_MIN_SSTKSZ(sstksz, "stksz+sstksz")$
			$ELSE$
$				// sstkszȗĂꍇ̏

$				// stkszC^[Qbg`̍ŏlꍇiE_PARj
				$CHECK_MIN_SSTKSZ(TSK.STKSZ[tskid], "stksz")$

$				// VXeX^bN̈̃TCY߂
				$sstksz = TSK.STKSZ[tskid]$
			$END$

$			// VXeX^bN̈̊m
			$ALLOC_SSTACK(CONCAT("_kernel_sstack_", tskid), sstksz)$
			$TSK.TINIB_SSTKSZ[tskid] = FORMAT("ROUND_STK_T(%1%)", sstksz)$
			$TSK.TINIB_SSTK[tskid] = CONCAT("_kernel_sstack_", tskid)$
		$ELSE$
$			// stkNULLłȂꍇ̏

$			// stkszC^[Qbg`̍ŏlꍇiE_PARj
			$CHECK_MIN_SSTKSZ(TSK.STKSZ[tskid], "stksz")$

$			// stkszX^bN̈̃TCY̐𖞂ĂȂꍇiE_PARj
			$IF CHECK_STKSZ_ALIGN
							&& (TSK.STKSZ[tskid] & (CHECK_STKSZ_ALIGN - 1))$
				$ERROR TSK.TEXT_LINE[tskid]$E_PAR: $FORMAT(_("%1% `%2%\' of `%3%\' in %4% is not aligned"), "stksz", TSK.STKSZ[tskid], tskid, "CRE_TSK")$$END$
			$END$

$			// sstkszȗĂ炸C0łȂꍇiE_PARj
			$IF LENGTH(TSK.SSTKSZ[tskid]) && (TSK.SSTKSZ[tskid] != 0)$
				$ERROR TSK.TEXT_LINE[tskid]$E_PAR: $FORMAT(_("%1% `%2%\' of `%3%\' in %4% must be 0"), "sstksz", TSK.SSTKSZ[tskid], tskid, "CRE_TSK")$$END$
			$END$

			$TSK.TINIB_SSTKSZ[tskid] = TSK.STKSZ[tskid]$
			$TSK.TINIB_SSTK[tskid] = TSK.STK[tskid]$
		$END$
	$ELSE$
$		// [U^XN̏ꍇ
		$IF !LENGTH(TSK.SSTK[tskid]) || EQ(TSK.SSTK[tskid],"NULL")$
$			// sstkȗĂ邩CNULL̏ꍇ̏

			$IF LENGTH(TSK.SSTKSZ[tskid])$
$				// sstkszȗĂȂꍇ̏

$				// sstksz0C^[Qbg`̍ŏlꍇiE_PARj
				$CHECK_MIN_SSTKSZ(TSK.SSTKSZ[tskid], "sstksz")$

$				// VXeX^bN̈̃TCY߂
				$sstksz = TSK.SSTKSZ[tskid]$
			$ELSE$
$				// sstkszȗĂꍇ̏

$				// VXeX^bN̈̃TCY߂
				$sstksz = "DEFAULT_SSTKSZ"$
			$END$

$			// VXeX^bN̈̊m
			$ALLOC_SSTACK(CONCAT("_kernel_sstack_", tskid), sstksz)$
			$TSK.TINIB_SSTKSZ[tskid] = FORMAT("ROUND_STK_T(%1%)", sstksz)$
			$TSK.TINIB_SSTK[tskid] = CONCAT("_kernel_sstack_", tskid)$
		$ELSE$
$			// sstkȗĂ炸CNULLłȂꍇ̏

$			// sstksz0C^[Qbg`̍ŏlꍇiE_PARj
			$CHECK_MIN_SSTKSZ(TSK.SSTKSZ[tskid], "sstksz")$

$			// sstkszX^bN̈̃TCY̐𖞂ĂȂꍇiE_PARj
			$IF CHECK_STKSZ_ALIGN
							&& (TSK.SSTKSZ[tskid] & (CHECK_STKSZ_ALIGN - 1))$
				$ERROR TSK.TEXT_LINE[tskid]$E_PAR: $FORMAT(_("%1% `%2%\' of `%3%\' in %4% is not aligned"), "sstksz", TSK.SSTKSZ[tskid], tskid, "CRE_TSK")$$END$
			$END$

			$TSK.TINIB_SSTKSZ[tskid] = TSK.SSTKSZ[tskid]$
			$TSK.TINIB_SSTK[tskid] = TSK.SSTK[tskid]$
		$END$
	$END$
$END$
$NL$

$ [UX^bN̈̐ƂɊւG[`FbN
$FOREACH tskid TSK.ID_LIST$
	$IF TSK.DOMAIN[tskid] == TDOM_KERNEL$
$		// VXe^XN̏ꍇ̏
		$TSK.TINIB_USTKSZ[tskid] = 0$
		$TSK.TINIB_USTK[tskid] = "NULL"$
	$ELSE$
$		// [U^XN̏ꍇ̏

$		// stksz0C^[Qbg`̍ŏliTARGET_MIN_USTKSZj
$		// ꍇiE_PARj
		$IF TSK.STKSZ[tskid] == 0 || (TARGET_MIN_USTKSZ && 
							TSK.STKSZ[tskid] < TARGET_MIN_USTKSZ)$
			$ERROR TSK.TEXT_LINE[tskid]$E_PAR: $FORMAT(_("%1% `%2%\' of `%3%\' in %4% is too small"), "stksz", TSK.STKSZ[tskid], tskid, "CRE_TSK")$$END$
		$END$

		$IF EQ(TSK.STK[tskid],"NULL")$
$			// stkNULL̏ꍇ̏

$			// [UX^bN̈̊m
			$ALLOC_USTACK(tskid, TSK.STKSZ[tskid])$
		$ELSE$
$			// stkNULLłȂ̏ꍇ̏

$			// stkszX^bN̈̃TCY̐𖞂ĂȂꍇiE_PARj
			$IF CHECK_USTKSZ_ALIGN
							&& (TSK.STKSZ[tskid] & (CHECK_USTKSZ_ALIGN - 1))$
				$ERROR TSK.TEXT_LINE[tskid]$E_PAR: $FORMAT(_("%1% `%2%\' of `%3%\' in %4% is not aligned"), "stksz", TSK.STKSZ[tskid], tskid, "CRE_TSK")$$END$
			$END$

			$TSK.TINIB_USTKSZ[tskid] = TSK.STKSZ[tskid]$
			$TSK.TINIB_USTK[tskid] = TSK.STK[tskid]$
		$END$

$		// IuWFNg̐
		$nummo = nummo + 1$
		$MO.TYPE[nummo] = TOPPERS_USTACK$
		$MO.TSKID[nummo] = tskid$
		$MO.SIZE[nummo] = TSK.TINIB_USTKSZ[tskid]$
		$IF !EQ(TSK.STK[tskid],"NULL")$
			$MO.BASE[nummo] = TSK.STK[tskid]$
			$MO.LINKER[nummo] = 0$
		$ELSE$
			$MO.LINKER[nummo] = 1$
			$MO.MEMREG[nummo] = STANDARD_RAM$
			$MO.SECTION[nummo] = SECTION_USTACK(tskid)$
			$MO_USTACK_LIST = APPEND(MO_USTACK_LIST, nummo)$
		$END$
		$MO.DOMAIN[nummo] = TSK.DOMAIN[tskid]$
		$MO.MEMATR[nummo] = TARGET_MEMATR_USTACK$

		$domptn = DEFAULT_ACPTN[MO.DOMAIN[nummo]]$
		$MO.ACPTN1[nummo] = domptn$
		$MO.ACPTN2[nummo] = domptn$
		$MO.ACPTN4[nummo] = domptn$
		$MO.TEXT_LINE[nummo] = TSK.TEXT_LINE[tskid]$
	$END$
$END$
$NL$

$ ^XNubN̐i^XN1ȏ㑶݂j
const TINIB _kernel_tinib_table[TNUM_TSKID] = {$NL$
$JOINEACH tskid TSK.ID_LIST ",\n"$
$	// یhCubN
	$TAB${
	$IF TSK.DOMAIN[tskid] == TDOM_KERNEL$
		$SPC$&_kernel_dominib_kernel,
	$ELSE$
		$SPC$&_kernel_dominib_table[INDEX_DOM($TSK.DOMAIN[tskid]$)],
	$END$

$	// ^XNCgCNԒnCNDx
	$SPC$($TSK.TSKATR[tskid]$), (intptr_t)($TSK.EXINF[tskid]$),
	$SPC$((TASK)($TSK.TASK[tskid]$)), INT_PRIORITY($TSK.ITSKPRI[tskid]$),

$	// ^XNReLXgubNCX^bN̈
	$IF USE_TSKINICTXB$
		$GENERATE_TSKINICTXB(tskid)$
	$ELSE$
		$SPC$$TSK.TINIB_SSTKSZ[tskid]$, $TSK.TINIB_SSTK[tskid]$,
		$SPC$$TSK.TINIB_USTKSZ[tskid]$, $TSK.TINIB_USTK[tskid]$,
	$END$

$	// ^XNO[`̑ƋNԒn
	$SPC$($ALT(TSK.TEXATR[tskid],"TA_NULL")$), ($ALT(TSK.TEXRTN[tskid],"NULL")$),

$	// ANZXxN^
	$IF LENGTH(TSK.ACPTN1[tskid])$
		$SPC${ $TSK.ACPTN1[tskid]$, $TSK.ACPTN2[tskid]$, $TSK.ACPTN3[tskid]$, $TSK.ACPTN4[tskid]$ }
	$ELSE$
		$DEFAULT_ACVCT[TSK.DOMAIN[tskid]]$
	$END$
	}
$END$$NL$
};$NL$
$NL$

$ ^XNǗubN̐
TCB _kernel_tcb_table[TNUM_TSKID];$NL$
$NL$

$ ^XNe[u̐
const ID _kernel_torder_table[TNUM_TSKID] = {$NL$
$TAB$$JOINEACH tskid TSK.ORDER_LIST ", "$$tskid$$END$$NL$
};$NL$
$NL$

$
$  Z}tH
$
/*$NL$
$SPC$*  Semaphore Functions$NL$
$SPC$*/$NL$
$NL$

$ Z}tHIDԍ̍ől
const ID _kernel_tmax_semid = (TMIN_SEMID + TNUM_SEMID - 1);$NL$
$NL$

$ Z}tHubN̐
$IF LENGTH(SEM.ID_LIST)$
	const SEMINIB _kernel_seminib_table[TNUM_SEMID] = {$NL$
	$JOINEACH semid SEM.ID_LIST ",\n"$
$		// sematrimTA_TPRInjłȂꍇiE_RSATRj
		$IF (SEM.SEMATR[semid] & ~TA_TPRI) != 0$
			$ERROR SEM.TEXT_LINE[semid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "sematr", SEM.SEMATR[semid], semid, "CRE_SEM")$$END$
		$END$

$		// (0 <= isemcnt && isemcnt <= maxsem)łȂꍇiE_PARj
		$IF !(0 <= SEM.ISEMCNT[semid] && SEM.ISEMCNT[semid] <= SEM.MAXSEM[semid])$
			$ERROR SEM.TEXT_LINE[semid]$E_PAR: $FORMAT(_("too large %1% `%2%\' of `%3%\' in %4%"), "isemcnt", SEM.ISEMCNT[semid], semid, "CRE_SEM")$$END$
		$END$

$		// (1 <= maxsem && maxsem <= TMAX_MAXSEM)łȂꍇiE_PARj
		$IF !(1 <= SEM.MAXSEM[semid] && SEM.MAXSEM[semid] <= TMAX_MAXSEM)$
			$ERROR SEM.TEXT_LINE[semid]$E_PAR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "maxsem", SEM.MAXSEM[semid], semid, "CRE_SEM")$$END$
		$END$

$		// Z}tHubN
		$TAB${ ($SEM.SEMATR[semid]$), ($SEM.ISEMCNT[semid]$), ($SEM.MAXSEM[semid]$),
		$IF LENGTH(SEM.ACPTN1[semid])$
			$SPC${ $SEM.ACPTN1[semid]$, $SEM.ACPTN2[semid]$, $SEM.ACPTN3[semid]$, $SEM.ACPTN4[semid]$ }
		$ELSE$
			$DEFAULT_ACVCT[ALT(SEM.DOMAIN[semid], TDOM_NONE)]$
		$END$
		}
	$END$$NL$
	};$NL$
	$NL$

$	// Z}tHǗubN
	SEMCB _kernel_semcb_table[TNUM_SEMID];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const SEMINIB, _kernel_seminib_table);$NL$
	TOPPERS_EMPTY_LABEL(SEMCB, _kernel_semcb_table);$NL$
$END$$NL$

$
$  CxgtO
$
/*$NL$
$SPC$*  Eventflag Functions$NL$
$SPC$*/$NL$
$NL$

$ CxgtOIDԍ̍ől
const ID _kernel_tmax_flgid = (TMIN_FLGID + TNUM_FLGID - 1);$NL$
$NL$

$ CxgtOubN̐
$IF LENGTH(FLG.ID_LIST)$
	const FLGINIB _kernel_flginib_table[TNUM_FLGID] = {$NL$
	$JOINEACH flgid FLG.ID_LIST ",\n"$
$		// flgatrimTA_TPRInbmTA_WMULnbmTA_CLRnjłȂꍇiE_RSATRj
		$IF (FLG.FLGATR[flgid] & ~(TA_TPRI|TA_WMUL|TA_CLR)) != 0$
			$ERROR FLG.TEXT_LINE[flgid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "flgatr", FLG.FLGATR[flgid], flgid, "CRE_FLG")$$END$
		$END$

$		// CxgtOubN
		$TAB${ ($FLG.FLGATR[flgid]$), ($FLG.IFLGPTN[flgid]$),
		$IF LENGTH(FLG.ACPTN1[flgid])$
			$SPC${ $FLG.ACPTN1[flgid]$, $FLG.ACPTN2[flgid]$, $FLG.ACPTN3[flgid]$, $FLG.ACPTN4[flgid]$ }
		$ELSE$
			$DEFAULT_ACVCT[ALT(FLG.DOMAIN[flgid], TDOM_NONE)]$
		$END$
		}
	$END$$NL$
	};$NL$
	$NL$

$	// CxgtOǗubN
	FLGCB _kernel_flgcb_table[TNUM_FLGID];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const FLGINIB, _kernel_flginib_table);$NL$
	TOPPERS_EMPTY_LABEL(FLGCB, _kernel_flgcb_table);$NL$
$END$$NL$

$
$  f[^L[
$
/*$NL$
$SPC$*  Dataqueue Functions$NL$
$SPC$*/$NL$
$NL$

$ f[^L[IDԍ̍ől
const ID _kernel_tmax_dtqid = (TMIN_DTQID + TNUM_DTQID - 1);$NL$
$NL$

$IF LENGTH(DTQ.ID_LIST)$
	$FOREACH dtqid DTQ.ID_LIST$
$		// dtqatrimTA_TPRInjłȂꍇiE_RSATRj
		$IF (DTQ.DTQATR[dtqid] & ~TA_TPRI) != 0$
			$ERROR DTQ.TEXT_LINE[dtqid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "dtqatr", DTQ.DTQATR[dtqid], dtqid, "CRE_DTQ")$$END$
		$END$

$		// dtqmbNULLłȂꍇiE_NOSPTj
		$IF !EQ(DTQ.DTQMB[dtqid], "NULL")$
			$ERROR DTQ.TEXT_LINE[dtqid]$E_NOSPT: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "dtqmb", DTQ.DTQMB[dtqid], dtqid, "CRE_DTQ")$$END$
		$END$

$		// f[^L[Ǘ̈
		$IF DTQ.DTQCNT[dtqid]$
			static DTQMB _kernel_dtqmb_$dtqid$[$DTQ.DTQCNT[dtqid]$];$NL$
		$END$
	$END$

$	// f[^L[ubN̐
	const DTQINIB _kernel_dtqinib_table[TNUM_DTQID] = {$NL$
	$JOINEACH dtqid DTQ.ID_LIST ",\n"$
		$TAB${ ($DTQ.DTQATR[dtqid]$), ($DTQ.DTQCNT[dtqid]$),
		$IF DTQ.DTQCNT[dtqid]$
			$SPC$(_kernel_dtqmb_$dtqid$),
		$ELSE$
			$SPC$NULL,
		$END$
		$IF LENGTH(DTQ.ACPTN1[dtqid])$
			$SPC${ $DTQ.ACPTN1[dtqid]$, $DTQ.ACPTN2[dtqid]$, $DTQ.ACPTN3[dtqid]$, $DTQ.ACPTN4[dtqid]$ }
		$ELSE$
			$DEFAULT_ACVCT[ALT(DTQ.DOMAIN[dtqid], TDOM_NONE)]$
		$END$
		}
	$END$$NL$
	};$NL$
	$NL$

$	// f[^L[ǗubN
	DTQCB _kernel_dtqcb_table[TNUM_DTQID];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const DTQINIB, _kernel_dtqinib_table);$NL$
	TOPPERS_EMPTY_LABEL(DTQCB, _kernel_dtqcb_table);$NL$
$END$$NL$

$
$  Dxf[^L[
$
/*$NL$
$SPC$*  Priority Dataqueue Functions$NL$
$SPC$*/$NL$
$NL$

$ Dxf[^L[IDԍ̍ől
const ID _kernel_tmax_pdqid = (TMIN_PDQID + TNUM_PDQID - 1);$NL$
$NL$

$IF LENGTH(PDQ.ID_LIST)$
	$FOREACH pdqid PDQ.ID_LIST$
$		// pdqatrimTA_TPRInjłȂꍇiE_RSATRj
		$IF (PDQ.PDQATR[pdqid] & ~TA_TPRI) != 0$
			$ERROR PDQ.TEXT_LINE[pdqid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "pdqatr", PDQ.PDQATR[pdqid], pdqid, "CRE_PDQ")$$END$
		$END$

$		// (TMIN_DPRI <= maxdpri && maxdpri <= TMAX_DPRI)łȂꍇiE_PARj
		$IF !(TMIN_DPRI <= PDQ.MAXDPRI[pdqid] && PDQ.MAXDPRI[pdqid] <= TMAX_DPRI)$
			$ERROR PDQ.TEXT_LINE[pdqid]$E_PAR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "maxdpri", PDQ.MAXDPRI[pdqid], pdqid, "CRE_PDQ")$$END$
		$END$

$		// pdqmbNULLłȂꍇiE_NOSPTj
		$IF !EQ(PDQ.PDQMB[pdqid], "NULL")$
			$ERROR PDQ.TEXT_LINE[pdqid]$E_NOSPT: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "pdqmb", PDQ.PDQMB[pdqid], pdqid, "CRE_PDQ")$$END$
		$END$

$		// Dxf[^L[Ǘ̈
		$IF PDQ.PDQCNT[pdqid]$
			static PDQMB _kernel_pdqmb_$pdqid$[$PDQ.PDQCNT[pdqid]$];$NL$
		$END$
	$END$

$	// Dxf[^L[ubN̐
	const PDQINIB _kernel_pdqinib_table[TNUM_PDQID] = {$NL$
	$JOINEACH pdqid PDQ.ID_LIST ",\n"$
		$TAB${ ($PDQ.PDQATR[pdqid]$), ($PDQ.PDQCNT[pdqid]$), ($PDQ.MAXDPRI[pdqid]$),
		$IF PDQ.PDQCNT[pdqid]$
			$SPC$(_kernel_pdqmb_$pdqid$),
		$ELSE$
			$SPC$NULL,
		$END$
		$IF LENGTH(PDQ.ACPTN1[pdqid])$
			$SPC${ $PDQ.ACPTN1[pdqid]$, $PDQ.ACPTN2[pdqid]$, $PDQ.ACPTN3[pdqid]$, $PDQ.ACPTN4[pdqid]$ }
		$ELSE$
			$DEFAULT_ACVCT[ALT(PDQ.DOMAIN[pdqid], TDOM_NONE)]$
		$END$
	}
	$END$$NL$
	};$NL$
	$NL$

$	// Dxf[^L[ǗubN
	PDQCB _kernel_pdqcb_table[TNUM_PDQID];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const PDQINIB, _kernel_pdqinib_table);$NL$
	TOPPERS_EMPTY_LABEL(PDQCB, _kernel_pdqcb_table);$NL$
$END$$NL$

$ 
$  ~[ebNX
$ 
/*$NL$
$SPC$*  Mutex Functions$NL$
$SPC$*/$NL$
$NL$

$ ~[ebNXIDԍ̍ől
const ID _kernel_tmax_mtxid = (TMIN_MTXID + TNUM_MTXID - 1);$NL$
$NL$

$ ~[ebNXubN̐
$IF LENGTH(MTX.ID_LIST)$
	const MTXINIB _kernel_mtxinib_table[TNUM_MTXID] = {$NL$
	$JOINEACH mtxid MTX.ID_LIST ",\n"$
$		// mtxatrimTA_TPRIbTA_CEILINGnjłȂꍇiE_RSATRj
		$IF !(MTX.MTXATR[mtxid] == 0 || MTX.MTXATR[mtxid] == TA_TPRI || MTX.MTXATR[mtxid] == TA_CEILING)$
			$ERROR MTX.TEXT_LINE[mtxid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "mtxatr", MTX.MTXATR[mtxid], mtxid, "CRE_MTX")$$END$
		$END$

$		// ceilpriw̏ꍇ0ƌȂ
		$IF !LENGTH(MTX.CEILPRI[mtxid])$
			$MTX.CEILPRI[mtxid] = 0$
		$END$
$		// (TMIN_TPRI <= ceilpri && ceilpri <= TMAX_TPRI)łȂꍇiE_PARj
		$IF MTX.MTXATR[mtxid] == TA_CEILING && (MTX.CEILPRI[mtxid] < TMIN_TPRI || TMAX_TPRI < MTX.CEILPRI[mtxid])$
			$ERROR MTX.TEXT_LINE[mtxid]$E_PAR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "ceilpri", MTX.CEILPRI[mtxid], mtxid, "CRE_MTX")$$END$
		$END$

$		// ~[ebNXubN
		$TAB${ ($MTX.MTXATR[mtxid]$), INT_PRIORITY($MTX.CEILPRI[mtxid]$),
		$IF LENGTH(MTX.ACPTN1[mtxid])$
			$SPC${ $MTX.ACPTN1[mtxid]$, $MTX.ACPTN2[mtxid]$, $MTX.ACPTN3[mtxid]$, $MTX.ACPTN4[mtxid]$ }
		$ELSE$
			$DEFAULT_ACVCT[ALT(MTX.DOMAIN[mtxid], TDOM_NONE)]$
		$END$
		}
	$END$$NL$
	};$NL$
	$NL$

$	// ~[ebNXǗubN
	MTXCB _kernel_mtxcb_table[TNUM_MTXID];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const MTXINIB, _kernel_mtxinib_table);$NL$
	TOPPERS_EMPTY_LABEL(MTXCB, _kernel_mtxcb_table);$NL$
$END$$NL$

$
$  Œ蒷v[
$
/*$NL$
$SPC$*  Fixed-sized Memorypool Functions$NL$
$SPC$*/$NL$
$NL$

$ Œ蒷v[IDԍ̍ől
const ID _kernel_tmax_mpfid = (TMIN_MPFID + TNUM_MPFID - 1);$NL$
$NL$

$IF LENGTH(MPF.ID_LIST)$
	$FOREACH mpfid MPF.ID_LIST$
		$MPF.HEW[mpfid] = 0$
$		// mpfatrimTA_TPRInjłȂꍇiE_RSATRj
		$IF (MPF.MPFATR[mpfid] & ~TA_TPRI) != 0$
			$ERROR MPF.TEXT_LINE[mpfid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "mpfatr", MPF.MPFATR[mpfid], mpfid, "CRE_MPF")$$END$
		$END$

$		// blkcnt0̏ꍇiE_PARj
		$IF MPF.BLKCNT[mpfid] == 0$
			$ERROR MPF.TEXT_LINE[mpfid]$E_PAR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "blkcnt", MPF.BLKCNT[mpfid], mpfid, "CRE_MPF")$$END$
		$END$

$		// blksz0̏ꍇiE_PARj
		$IF MPF.BLKSZ[mpfid] == 0$
			$ERROR MPF.TEXT_LINE[mpfid]$E_PAR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "blksz", MPF.BLKSZ[mpfid], mpfid, "CRE_MPF")$$END$
		$END$

$		// Œ蒷v[̈
		$IF EQ(MPF.MPF[mpfid], "NULL")$
			$IF LENGTH(MPF.DOMAIN[mpfid]) && (MPF.DOMAIN[mpfid] == TDOM_KERNEL)
					&& (!LENGTH(MPF.ACPTN1[mpfid]) || 
							(MPF.ACPTN1[mpfid] == TACP_KERNEL
								&& MPF.ACPTN2[mpfid] == TACP_KERNEL
								&& MPF.ACPTN4[mpfid] == TACP_KERNEL))$
$				// J[lhCɑCANZXxN^W
$				// Œ蒷v[̏ꍇ
				static MPF_T _kernel_mpf_$mpfid$[($MPF.BLKCNT[mpfid]$) * COUNT_MPF_T($MPF.BLKSZ[mpfid]$)];$NL$
			$ELSE$
$				// LȊǑŒ蒷v[̏ꍇ
				$domid = ALT(MPF.DOMAIN[mpfid], TDOM_NONE)$
				
				$ALLOC_UMPF_2(mpfid, domid, MPF.BLKCNT[mpfid], MPF.BLKSZ[mpfid])$

$				// IuWFNg̐
				$nummo = nummo + 1$
				$MO.TYPE[nummo] = TOPPERS_MPFAREA$
				$MO.MPFID[nummo] = mpfid$
				$MO.LINKER[nummo] = 1$
				$MO.DOMAIN[nummo] = domid$
				$MO.MEMREG[nummo] = STANDARD_RAM$
				$MO.SECTION[nummo] = SECTION_UMPF(mpfid)$
				$MO.MEMATR[nummo] = TARGET_MEMATR_MPFAREA$

				$domptn = DEFAULT_ACPTN[MO.DOMAIN[nummo]]$
				$MO.ACPTN1[nummo] = ALT(MPF.ACPTN1[mpfid], domptn)$
				$MO.ACPTN2[nummo] = ALT(MPF.ACPTN2[mpfid], domptn)$
				$MO.ACPTN4[nummo] = ALT(MPF.ACPTN4[mpfid], domptn)$
				$MO.TEXT_LINE[nummo] = MPF.TEXT_LINE[mpfid]$
				
				$MPF.HEW[mpfid] = nummo$
			$END$
		$END$

$		// mpfmbNULLłȂꍇiE_NOSPTj
		$IF !EQ(MPF.MPFMB[mpfid], "NULL")$
			$ERROR MPF.TEXT_LINE[mpfid]$E_NOSPT: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "mpfmb", MPF.MPFMB[mpfid], mpfid, "CRE_MPF")$$END$
		$END$

$		// Œ蒷v[Ǘ̈
		static MPFMB _kernel_mpfmb_$mpfid$[$MPF.BLKCNT[mpfid]$];$NL$
	$END$

$	// Œ蒷v[ubN̐
	const MPFINIB _kernel_mpfinib_table[TNUM_MPFID] = {$NL$
	$JOINEACH mpfid MPF.ID_LIST ",\n"$
		$TAB${ ($MPF.MPFATR[mpfid]$), ($MPF.BLKCNT[mpfid]$), ROUND_MPF_T($MPF.BLKSZ[mpfid]$),
		$IF EQ(MPF.MPF[mpfid],"NULL")$
			$SPC$(_kernel_mpf_$mpfid$),
		$ELSE$
			$SPC$($MPF.MPF[mpfid]$),
		$END$
		$SPC$(_kernel_mpfmb_$mpfid$),
		$IF LENGTH(MPF.ACPTN1[mpfid])$
			$SPC${ $MPF.ACPTN1[mpfid]$, $MPF.ACPTN2[mpfid]$, $MPF.ACPTN3[mpfid]$, $MPF.ACPTN4[mpfid]$ }
		$ELSE$
			$DEFAULT_ACVCT[ALT(MPF.DOMAIN[mpfid], TDOM_NONE)]$
		$END$
		}
	$END$$NL$
	};$NL$
	$NL$

$	// Œ蒷v[ǗubN
	MPFCB _kernel_mpfcb_table[TNUM_MPFID];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const MPFINIB, _kernel_mpfinib_table);$NL$
	TOPPERS_EMPTY_LABEL(MPFCB, _kernel_mpfcb_table);$NL$
$END$$NL$

$
$  nh
$
/*$NL$
$SPC$*  Cyclic Handler Functions$NL$
$SPC$*/$NL$
$NL$

$ nhIDԍ̍ől
const ID _kernel_tmax_cycid = (TMIN_CYCID + TNUM_CYCID - 1);$NL$
$NL$

$ nhe[u̐
$IF LENGTH(CYC.ID_LIST)$
	const CYCINIB _kernel_cycinib_table[TNUM_CYCID] = {$NL$
	$JOINEACH cycid CYC.ID_LIST ",\n"$
$		// J[lhCɏĂȂꍇiE_RSATRj
		$IF !LENGTH(CYC.DOMAIN[cycid]) || CYC.DOMAIN[cycid] != TDOM_KERNEL$
			$ERROR CYC.TEXT_LINE[cycid]$E_RSATR: $FORMAT(_("%1% `%2%\' must belong to the kernel domain in %3%"), "cyclic handler", cycid, "CRE_CYC")$$END$
$			// ȍ~̃G[̗}~
			$CYC.DOMAIN[cycid] = TDOM_KERNEL$
		$END$

$		// cycatrimTA_STAnjłȂꍇiE_RSATRj
		$IF (CYC.CYCATR[cycid] & ~TA_STA) != 0$
			$ERROR CYC.TEXT_LINE[cycid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "cycatr", CYC.CYCATR[cycid], cycid, "CRE_CYC")$$END$
		$END$

$		// (0 < cyctim && cyctim <= TMAX_RELTIM)łȂꍇiE_PARj
		$IF !(0 < CYC.CYCTIM[cycid] && CYC.CYCTIM[cycid] <= TMAX_RELTIM)$
			$ERROR CYC.TEXT_LINE[cycid]$E_PAR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "cyctim", CYC.CYCTIM[cycid], cycid, "CRE_CYC")$$END$
		$END$

$		// (0 <= cycphs && cycphs <= TMAX_RELTIM)łȂꍇiE_PARj
		$IF !(0 <= CYC.CYCPHS[cycid] && CYC.CYCPHS[cycid] <= TMAX_RELTIM)$
			$ERROR CYC.TEXT_LINE[cycid]$E_PAR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "cycphs", CYC.CYCPHS[cycid], cycid, "CRE_CYC")$$END$
		$END$

$		// xFcycatrTA_STAݒ肳ĂāC(cycphs == 0)̏ꍇ
		$IF (CYC.CYCATR[cycid] & TA_STA) != 0 && CYC.CYCPHS[cycid] == 0$
			$WARNING CYC.TEXT_LINE[cycid]$$FORMAT(_("%1% is not recommended when %2% is set to %3% in %4%"), "cycphs==0", "TA_STA", "cycatr", "CRE_CYC")$$END$
		$END$

$		// nhubN
		$TAB${ ($CYC.CYCATR[cycid]$), (intptr_t)($CYC.EXINF[cycid]$), ($CYC.CYCHDR[cycid]$), ($CYC.CYCTIM[cycid]$), ($CYC.CYCPHS[cycid]$),
		$IF LENGTH(CYC.ACPTN1[cycid])$
			$SPC${ $CYC.ACPTN1[cycid]$, $CYC.ACPTN2[cycid]$, $CYC.ACPTN3[cycid]$, $CYC.ACPTN4[cycid]$ }
		$ELSE$
			$DEFAULT_ACVCT[CYC.DOMAIN[cycid]]$
		$END$
		}
	$END$$NL$
	};$NL$
	$NL$

$	// nhǗubN
	CYCCB _kernel_cyccb_table[TNUM_CYCID];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const CYCINIB, _kernel_cycinib_table);$NL$
	TOPPERS_EMPTY_LABEL(CYCCB, _kernel_cyccb_table);$NL$
$END$$NL$

$
$  A[nh
$
/*$NL$
$SPC$*  Alarm Handler Functions$NL$
$SPC$*/$NL$
$NL$

$ A[nhIDԍ̍ől
const ID _kernel_tmax_almid = (TMIN_ALMID + TNUM_ALMID - 1);$NL$
$NL$

$ A[nhubN̐
$IF LENGTH(ALM.ID_LIST)$
	const ALMINIB _kernel_alminib_table[TNUM_ALMID] = {$NL$
	$JOINEACH almid ALM.ID_LIST ",\n"$
$		// یhCɏĂȂꍇiE_RSATRj
		$IF !LENGTH(ALM.DOMAIN[almid]) || ALM.DOMAIN[almid] != TDOM_KERNEL$
			$ERROR ALM.TEXT_LINE[almid]$E_RSATR: $FORMAT(_("%1% `%2%\' must belong to the kernel domain in %3%"), "alarm handler", almid, "CRE_ALM")$$END$
$			// ȍ~̃G[̗}~
			$ALM.DOMAIN[almid] = TDOM_KERNEL$
		$END$

$		// almatriTA_NULLjłȂꍇiE_RSATRj
		$IF ALM.ALMATR[almid] != 0$
			$ERROR ALM.TEXT_LINE[almid]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"), "almatr", ALM.ALMATR[almid], almid, "CRE_ALM")$$END$
		$END$

$		// A[nhubN
		$TAB${ ($ALM.ALMATR[almid]$), (intptr_t)($ALM.EXINF[almid]$), ($ALM.ALMHDR[almid]$),
		$IF LENGTH(ALM.ACPTN1[almid])$
			$SPC${ $ALM.ACPTN1[almid]$, $ALM.ACPTN2[almid]$, $ALM.ACPTN3[almid]$, $ALM.ACPTN4[almid]$ }
		$ELSE$
			$DEFAULT_ACVCT[ALM.DOMAIN[almid]]$
		$END$
		}
	$END$$NL$
	};$NL$
	$NL$

$	// A[nhǗubN
	ALMCB _kernel_almcb_table[TNUM_ALMID];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const ALMINIB, _kernel_alminib_table);$NL$
	TOPPERS_EMPTY_LABEL(ALMCB, _kernel_almcb_table);$NL$
$END$$NL$

$
$  I[onh
$
/*$NL$
$SPC$*  Overrun Handler Functions$NL$
$SPC$*/$NL$
$NL$

$ G[`FbN
$IF LENGTH(OVR.ORDER_LIST)$
$	// ÓIAPIuDEF_OVRviE_OBJj
	$IF LENGTH(OVR.ORDER_LIST) > 1$
		$ERROR$E_OBJ: $FORMAT(_("too many %1%"), "DEF_OVR")$$END$
	$END$

$	// J[lhCɏĂȂꍇiE_RSATRj
	$IF !LENGTH(OVR.DOMAIN[1]) || OVR.DOMAIN[1] != TDOM_KERNEL$
		$ERROR OVR.TEXT_LINE[1]$E_RSATR: $FORMAT(_("%1% must belong to the kernel domain in %2%"), "overrun handler", "DEF_OVR")$$END$
	$END$
$END$

$ I[onhubN̐
#ifdef TOPPERS_SUPPORT_OVRHDR$NL$$NL$
const OVRINIB _kernel_ovrinib = {$NL$
$IF LENGTH(OVR.ORDER_LIST)$
	$TAB$($OVR.OVRATR[1]$), ($OVR.OVRHDR[1]$)$NL$
$ELSE$
	$TAB$TA_NULL, NULL$NL$
$END$
};$NL$$NL$
#endif /* TOPPERS_SUPPORT_OVRHDR */$NL$
$NL$

$
$  VXeԊǗ@\
$
/*$NL$
$SPC$*  System State Management Functions$NL$
$SPC$*/$NL$
$NL$

const ACVCT _kernel_sysstat_acvct =
$IF !LENGTH(SYS.ORDER_LIST)$
$	// SAC_SYSȂꍇ̃ftHgl̐ݒ
	$SPC${ TACP_KERNEL, TACP_KERNEL, TACP_KERNEL, TACP_KERNEL }
$ELSE$
$	// SAC_SYSꍇ
$	// ÓIAPIuSAC_SYSviE_OBJj
	$IF LENGTH(SYS.ORDER_LIST) > 1$
		$ERROR$E_OBJ: $FORMAT(_("too many %1%"), "SAC_SYS")$$END$
	$END$

$	// J[lhC݂̈͂̒ɂȂꍇiE_RSATRj
	$IF !LENGTH(SYS.DOMAIN[1]) || SYS.DOMAIN[1] != TDOM_KERNEL$
		$ERROR SYS.TEXT_LINE[1]$E_RSATR: $FORMAT(_("%1% must be within the kernel domain"), "SAC_SYS")$$END$
	$END$

	$SPC${ $SYS.ACPTN1[1]$, $SYS.ACPTN2[1]$, $SYS.ACPTN3[1]$, $SYS.ACPTN4[1]$ }
$END$
;$NL$
$NL$

$
$  ݊Ǘ@\
$
/*$NL$
$SPC$*  Interrupt Management Functions$NL$
$SPC$*/$NL$
$NL$

$ ݔԍƊ݃nhԍ̕ϊe[u̍쐬
$IF LENGTH(INTNO_ATTISR_VALID) != LENGTH(INHNO_ATTISR_VALID)$
	$ERROR$length of `INTNO_ATTISR_VALID' is different from length of `INHNO_ATTISR_VALID'$END$
$END$
$i = 0$
$FOREACH intno INTNO_ATTISR_VALID$
	$inhno = AT(INHNO_ATTISR_VALID, i)$
	$INHNO[intno] = inhno$
	$INTNO[inhno] = intno$
	$i = i + 1$
$END$

$ ݗvCɊւG[`FbN
$i = 0$
$FOREACH intno INT.ORDER_LIST$
$	// J[lhC݂̈͂̒ɂȂꍇiE_RSATRj
	$IF !LENGTH(INT.DOMAIN[intno]) || INT.DOMAIN[intno] != TDOM_KERNEL$
		$ERROR INT.TEXT_LINE[intno]$E_RSATR: $FORMAT(_("%1% must be within the kernel domain"), "CFG_INT")$$END$
	$END$

$	// intnoCFG_INTɑ΂銄ݔԍƂĐȂꍇiE_PARj
	$IF !LENGTH(FIND(INTNO_CFGINT_VALID, INT.INTNO[intno]))$
		$ERROR INT.TEXT_LINE[intno]$E_PAR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "intno", INT.INTNO[intno], "CFG_INT")$$END$
	$END$

$	// intnoCFG_INTɂĐݒς݂̏ꍇiE_OBJj
	$j = 0$
	$FOREACH intno2 INT.ORDER_LIST$
		$IF j < i && INT.INTNO[intno] == INT.INTNO[intno2]$
			$ERROR INT.TEXT_LINE[intno]$E_OBJ: $FORMAT(_("%1% `%2%\' in %3% is duplicated"), "intno", INT.INTNO[intno], "CFG_INT")$$END$
		$END$
		$j = j + 1$
	$END$

$	// intatrimTA_ENAINTnbmTA_EDGEnjłȂꍇiE_RSATRj
	$IF (INT.INTATR[intno] & ~(TA_ENAINT|TA_EDGE|TARGET_INTATR)) != 0$
		$ERROR INT.TEXT_LINE[intno]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of %3% `%4%\' in %5%"), "intatr", INT.INTATR[intno], "intno", INT.INTNO[intno], "CFG_INT")$$END$
	$END$

$	// intpriCFG_INTɑ΂銄ݗDxƂĐȂꍇiE_PARj
	$IF !LENGTH(FIND(INTPRI_CFGINT_VALID, INT.INTPRI[intno]))$
		$ERROR INT.TEXT_LINE[intno]$E_PAR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "intpri", INT.INTPRI[intno], "CFG_INT")$$END$
	$END$

$	// J[lǗɌŒ肳Ăintnoɑ΂āCintpriTMIN_INTPRI
$	// lw肳ꂽꍇiE_OBJj
	$IF LENGTH(FIND(INTNO_FIX_KERNEL, intno))$
		$IF INT.INTPRI[intno] < TMIN_INTPRI$
			$ERROR INT.TEXT_LINE[intno]$E_OBJ: $FORMAT(_("%1% `%2%\' must not have higher priority than %3%"), "intno", INT.INTNO[intno], "TMIN_INTPRI")$$END$
		$END$
	$END$

$	// J[lǗOɌŒ肳Ăintnoɑ΂āCintpriTMIN_INTPRI
$	// lw肳ȂꍇiE_OBJj
	$IF LENGTH(FIND(INTNO_FIX_NONKERNEL, intno))$
		$IF INT.INTPRI[intno] >= TMIN_INTPRI$
			$ERROR INT.TEXT_LINE[intno]$E_OBJ: $FORMAT(_("%1% `%2%\' must have higher priority than %3%"), "intno", INT.INTNO[intno], "TMIN_INTPRI")$$END$
		$END$
	$END$
	$i = i + 1$
$END$

$ ݃nhɊւG[`FbN
$i = 0$
$FOREACH inhno INH.ORDER_LIST$
$	// J[lhCɏĂȂꍇiE_RSATRj
	$IF !LENGTH(INH.DOMAIN[inhno]) || INH.DOMAIN[inhno] != TDOM_KERNEL$
		$ERROR INH.TEXT_LINE[inhno]$E_RSATR: $FORMAT(_("%1% `%2%\' must belong to the kernel domain in %3%"), "interrupt handler", INH.INHNO[inhno], "DEF_INH")$$END$
	$END$

$	// inhnoDEF_INHɑ΂銄݃nhԍƂĐȂꍇiE_PARj
	$IF !LENGTH(FIND(INHNO_DEFINH_VALID, INH.INHNO[inhno]))$
		$ERROR INH.TEXT_LINE[inhno]$E_PAR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "inhno", INH.INHNO[inhno], "DEF_INH")$$END$
	$END$

$	// inhnoDEF_INHɂĐݒς݂̏ꍇiE_OBJj
	$j = 0$
	$FOREACH inhno2 INH.ORDER_LIST$
		$IF j < i && INH.INHNO[inhno] == INH.INHNO[inhno2]$
			$ERROR INH.TEXT_LINE[inhno]$E_OBJ: $FORMAT(_("%1% `%2%\' in %3% is duplicated"), "inhno", INH.INHNO[inhno], "DEF_INH")$$END$
		$END$
		$j = j + 1$
	$END$

$	// inhatriTA_NULLjłȂꍇiE_RSATRj
	$IF (INH.INHATR[inhno] & ~TARGET_INHATR) != 0$
		$ERROR INH.TEXT_LINE[inhno]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of %3% `%4%\' in %5%"), "inhatr", INH.INHATR[inhno], "inhno", INH.INHNO[inhno], "DEF_INH")$$END$
	$END$

$	// J[lǗɌŒ肳Ăinhnoɑ΂āCinhatrTA_NONKERNEL
$	//@w肳ĂꍇiE_RSATRj
	$IF LENGTH(FIND(INHNO_FIX_KERNEL, inhno))$
		$IF (INH.INHATR[inhno] & TA_NONKERNEL) != 0$
			$ERROR INH.TEXT_LINE[inhno]$E_RSATR: $FORMAT(_("%1% `%2%\' must not be non-kernel interrupt"), "inhno", INH.INHNO[inhno])$$END$
		$END$
	$END$

$	// J[lǗOɌŒ肳Ăinhnoɑ΂āCinhatrTA_NONKERNEL
$	// w肳ĂȂꍇiE_RSATRj
	$IF LENGTH(FIND(INHNO_FIX_NONKERNEL, inhno))$
		$IF (INH.INHATR[inhno] & TA_NONKERNEL) == 0$
			$ERROR INH.TEXT_LINE[inhno]$E_RSATR: $FORMAT(_("%1% `%2%\' must be non-kernel interrupt"), "inhno", INH.INHNO[inhno])$$END$
		$END$
	$END$

	$IF LENGTH(INTNO[INH.INHNO[inhno]])$
		$intno = INTNO[INH.INHNO[inhno]]$
		$IF LENGTH(FIND(INTNO_CFGINT_VALID, intno))$
$			// inhnoɑΉintnoɑ΂CFG_INTȂꍇiE_OBJj
			$IF !LENGTH(INT.INTNO[intno])$
				$ERROR INH.TEXT_LINE[inhno]$E_OBJ: $FORMAT(_("%1% `%2%\' corresponding to %3% `%4%\' is not configured with %5%"), "intno", INT.INTNO[intno], "inhno", INH.INHNO[inhno], "CFG_INT")$$END$
			$ELSE$
				$IF (INH.INHATR[inhno] & TA_NONKERNEL) == 0$
$					// inhatrTA_NONKERNELw肳Ă炸CinhnoɑΉ
$					// intnoɑ΂CFG_INTŐݒ肳ꂽݗDx
$					// TMIN_INTPRIꍇiE_OBJj
					$IF INT.INTPRI[intno] < TMIN_INTPRI$
						$ERROR INT.TEXT_LINE[intno]$E_OBJ: $FORMAT(_("%1% `%2%\' configured for %3% `%4%\' is higher than %5%"), "intpri", INT.INTPRI[intno], "inhno", INH.INHNO[inhno], "TMIN_INTPRI")$$END$
					$END$
				$ELSE$
$					// inhatrTA_NONKERNELw肳ĂCinhnoɑΉ
$					// intnoɑ΂CFG_INTŐݒ肳ꂽݗDx
$					// TMIN_INTPRIȏłꍇiE_OBJj
					$IF INT.INTPRI[intno] >= TMIN_INTPRI$
						$ERROR INT.TEXT_LINE[intno]$E_OBJ: $FORMAT(_("%1% `%2%\' configured for %3% `%4%\' is lower than or equal to %5%"), "intpri", INT.INTPRI[intno], "inhno", INH.INHNO[inhno], "TMIN_INTPRI")$$END$
					$END$
				$END$
			$END$
		$END$
	$END$
	$i = i + 1$
$END$

$ ݃T[rX[`iISRjɊւG[`FbNƊ݃nh̐
$FOREACH order ISR.ORDER_LIST$
$	// J[lhCɏĂȂꍇiE_RSATRj
	$IF !LENGTH(ISR.DOMAIN[order]) || ISR.DOMAIN[order] != TDOM_KERNEL$
		$ERROR ISR.TEXT_LINE[order]$E_RSATR: $FORMAT(_("%1% must belong to the kernel domain in %2%"), "interrupt service routine", "ATT_ISR")$$END$
	$END$

$	// isratriTA_NULLjłȂꍇiE_RSATRj
	$IF (ISR.ISRATR[order] & ~TARGET_ISRATR) != 0$
		$ERROR ISR.TEXT_LINE[order]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "isratr", ISR.ISRATR[order], "ATT_ISR")$$END$
	$END$

$	// intnoATT_ISRɑ΂銄ݔԍƂĐȂꍇiE_PARj
	$IF !LENGTH(FIND(INTNO_ATTISR_VALID, ISR.INTNO[order]))$
		$ERROR ISR.TEXT_LINE[order]$E_PAR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "intno", ISR.INTNO[order], "ATT_ISR")$$END$
	$END$

$	// (TMIN_ISRPRI <= isrpri && isrpri <= TMAX_ISRPRI)łȂꍇiE_PARj
	$IF !(TMIN_ISRPRI <= ISR.ISRPRI[order] && ISR.ISRPRI[order] <= TMAX_ISRPRI)$
		$ERROR ISR.TEXT_LINE[order]$E_PAR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "isrpri", ISR.ISRPRI[order], "ATT_ISR")$$END$
	$END$
$END$

$FOREACH intno INTNO_ATTISR_VALID$
	$inhno = INHNO[intno]$

$	// ݔԍintnoɑ΂ēo^ꂽISR̃Xg̍쐬
	$isr_order_list = {}$
	$FOREACH order ISR.ORDER_LIST$
		$IF ISR.INTNO[order] == intno$
			$isr_order_list = APPEND(isr_order_list, order)$
			$order_for_error = order$
		$END$
	$END$

$	// ݔԍintnoɑ΂ēo^ꂽISR݂ꍇ
	$IF LENGTH(isr_order_list) > 0$
$		// intnoɑΉinhnoɑ΂DEF_INHꍇiE_OBJj
		$IF LENGTH(INH.INHNO[inhno])$
			$ERROR ISR.TEXT_LINE[order_for_error]$E_OBJ: $FORMAT(_("%1% `%2%\' in %3% is duplicated with %4% `%5%\'"), "intno", ISR.INTNO[order_for_error], "ATT_ISR", "inhno", INH.INHNO[inhno])$$END$
		$END$

$		// intnoɑ΂CFG_INTȂꍇiE_OBJj
		$IF !LENGTH(INT.INTNO[intno])$
			$ERROR ISR.TEXT_LINE[order_for_error]$E_OBJ: $FORMAT(_("%1% `%2%\' is not configured with %3%"), "intno", ISR.INTNO[order_for_error], "CFG_INT")$$END$
		$ELSE$
$			// intnoɑ΂CFG_INTŐݒ肳ꂽݗDxTMIN_INTPRI
$			// ꍇiE_OBJj
			$IF INT.INTPRI[intno] < TMIN_INTPRI$
				$ERROR INT.TEXT_LINE[intno]$E_OBJ: $FORMAT(_("%1% `%2%\' configured for %3% `%4%\' is higher than %5%"), "intpri", INT.INTPRI[intno], "intno", ISR.INTNO[order_for_error], "TMIN_INTPRI")$$END$
			$END$
		$END$

$		// DEF_INH(inhno, { TA_NULL, _kernel_inthdr_<intno> } );
		$INH.INHNO[inhno] = inhno$
		$INH.INHATR[inhno] = VALUE("TA_NULL", 0)$
		$INH.INTHDR[inhno] = CONCAT("_kernel_inthdr_", intno)$
		$INH.ORDER_LIST = APPEND(INH.ORDER_LIST, inhno)$

$		// ISRp̊݃nh
		void$NL$
		_kernel_inthdr_$intno$(void)$NL$
		{$NL$
		$IF LENGTH(isr_order_list) > 1$
			$TAB$PRI	saved_ipm;$NL$
			$NL$
			$TAB$i_begin_int($intno$);$NL$
			$TAB$saved_ipm = i_get_ipm();$NL$
		$ELSE$
			$TAB$i_begin_int($intno$);$NL$
		$END$
$		// ISRDxɌĂяo
		$JOINEACH order SORT(isr_order_list, "ISR.ISRPRI") "\tif (i_sense_lock()) {\n\t\ti_unlock_cpu();\n\t}\n\ti_set_ipm(saved_ipm);\n"$
			$TAB$LOG_ISR_ENTER($intno$);$NL$
			$TAB$((ISR)($ISR.ISR[order]$))((intptr_t)($ISR.EXINF[order]$));$NL$
			$TAB$LOG_ISR_LEAVE($intno$);$NL$
		$END$
		$TAB$i_end_int($intno$);$NL$
		}$NL$
	$END$
$END$
$NL$

$
$  ݊Ǘ@\̂߂̕WIȏ̐
$
$ ݃nh̏ɕKvȏ
$IF !OMIT_INITIALIZE_INTERRUPT || ALT(USE_INHINIB_TABLE,0)$

$ ݃nh
#define TNUM_INHNO	$LENGTH(INH.ORDER_LIST)$$NL$
const uint_t _kernel_tnum_inhno = TNUM_INHNO;$NL$
$NL$
$FOREACH inhno INH.ORDER_LIST$
	$IF (INH.INHATR[inhno] & TA_NONKERNEL) == 0$
		INTHDR_ENTRY($INH.INHNO[inhno]$, $+INH.INHNO[inhno]$, $INH.INTHDR[inhno]$)$NL$
	$END$
$END$
$NL$

$ ݃nhe[u
$IF LENGTH(INH.ORDER_LIST)$
	const INHINIB _kernel_inhinib_table[TNUM_INHNO] = {$NL$
	$JOINEACH inhno INH.ORDER_LIST ",\n"$
		$IF (INH.INHATR[inhno] & TA_NONKERNEL) == 0$
			$TAB${ ($INH.INHNO[inhno]$), ($INH.INHATR[inhno]$), (FP)(INT_ENTRY($INH.INHNO[inhno]$, $INH.INTHDR[inhno]$)) }
		$ELSE$
			$TAB${ ($INH.INHNO[inhno]$), ($INH.INHATR[inhno]$), (FP)($INH.INTHDR[inhno]$) }
		$END$
	$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const INHINIB, _kernel_inhinib_table);$NL$
$END$$NL$
$END$

$ ݗvC̏ɕKvȏ
$IF !OMIT_INITIALIZE_INTERRUPT || ALT(USE_INHINTB_TABLE,0)$

$ ݗvC
#define TNUM_INTNO	$LENGTH(INT.ORDER_LIST)$$NL$
const uint_t _kernel_tnum_intno = TNUM_INTNO;$NL$
$NL$

$ ݗvCe[u
$IF LENGTH(INT.ORDER_LIST)$
	const INTINIB _kernel_intinib_table[TNUM_INTNO] = {$NL$
	$JOINEACH intno INT.ORDER_LIST ",\n"$
		$TAB${ ($INT.INTNO[intno]$), ($INT.INTATR[intno]$), ($INT.INTPRI[intno]$) }
	$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const INTINIB, _kernel_intinib_table);$NL$
$END$$NL$
$END$

$
$  CPUOǗ@\
$
/*$NL$
$SPC$*  CPU Exception Management Functions$NL$
$SPC$*/$NL$
$NL$

$ CPUOnhɊւG[`FbN
$i = 0$
$FOREACH excno EXC.ORDER_LIST$
$	// J[lhCɏĂȂꍇiE_RSATRj
	$IF !LENGTH(EXC.DOMAIN[excno]) || EXC.DOMAIN[excno] != TDOM_KERNEL$
		$ERROR EXC.TEXT_LINE[excno]$E_RSATR: $FORMAT(_("%1% `%2%\' must belong to the kernel domain in %3%"), "CPU exception handler", EXC.EXCNO[excno], "DEF_EXC")$$END$
	$END$

$	// excnoDEF_EXCɑ΂CPUOnhԍƂĐȂꍇiE_PARj
	$IF !LENGTH(FIND(EXCNO_DEFEXC_VALID, EXC.EXCNO[excno]))$
		$ERROR EXC.TEXT_LINE[excno]$E_PAR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "excno", EXC.EXCNO[excno], "DEF_EXC")$$END$
	$END$

$	// excnoDEF_EXCɂĐݒς݂̏ꍇiE_OBJj
	$j = 0$
	$FOREACH excno2 EXC.ORDER_LIST$
		$IF j < i && EXC.EXCNO[excno] == EXC.EXCNO[excno2]$
			$ERROR EXC.TEXT_LINE[excno]$E_OBJ: $FORMAT(_("%1% `%2%\' in %3% is duplicated"), "excno", EXC.EXCNO[excno], "DEF_EXC")$$END$
		$END$
		$j = j + 1$
	$END$

$	// excatriTA_NULLjłȂꍇiE_RSATRj
	$IF (EXC.EXCATR[excno] & ~TARGET_EXCATR) != 0$
		$ERROR EXC.TEXT_LINE[excno]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of %3% `%4%\' in %5%"), "excatr", EXC.EXCATR[excno], "excno", EXC.EXCNO[excno], "DEF_EXC")$$END$
	$END$
	$i = i + 1$
$END$

$ CPUOnĥ߂̕WIȏ̐
$IF !OMIT_INITIALIZE_EXCEPTION$

$ CPUOnh
#define TNUM_EXCNO	$LENGTH(EXC.ORDER_LIST)$$NL$
const uint_t _kernel_tnum_excno = TNUM_EXCNO;$NL$
$NL$
$FOREACH excno EXC.ORDER_LIST$
	EXCHDR_ENTRY($EXC.EXCNO[excno]$, $+EXC.EXCNO[excno]$, $EXC.EXCHDR[excno]$)$NL$
$END$
$NL$

$ CPUOnhe[u
$IF LENGTH(EXC.ORDER_LIST)$
	const EXCINIB _kernel_excinib_table[TNUM_EXCNO] = {$NL$
	$JOINEACH excno EXC.ORDER_LIST ",\n"$
		$TAB${ ($EXC.EXCNO[excno]$), ($EXC.EXCATR[excno]$), (FP)(EXC_ENTRY($EXC.EXCNO[excno]$, $EXC.EXCHDR[excno]$)) }
	$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const EXCINIB, _kernel_excinib_table);$NL$
$END$$NL$
$END$

$
$  gT[rXR[
$
/*$NL$
$SPC$*  Extended Service Calls$NL$
$SPC$*/$NL$
$NL$

$ gT[rXR[ɊւG[`FbN
$ SVC_LISTFς݂̊gT[rXR[̃Xg
$
$FOREACH order SVC.ORDER_LIST$
$	// J[lhCɏĂȂꍇiE_RSATRj
	$IF !LENGTH(SVC.DOMAIN[order]) || SVC.DOMAIN[order] != TDOM_KERNEL$
		$ERROR SVC.TEXT_LINE[order]$E_RSATR: $FORMAT(_("%1% `%2%\' must belong to the kernel domain in %3%"), "extended service call", SVC.FNCD[order], "DEF_SVC")$$END$
	$END$

$	// fncdDEF_SVCɑ΂@\R[hƂĐȂꍇiE_PARj
	$IF SVC.FNCD[order] <= 0$
		$ERROR SVC.TEXT_LINE[order]$E_PAR: $FORMAT(_("illegal %1% `%2%\' in %3%"), "fncd", SVC.FNCD[order], "DEF_SVC")$$END$
	$END$

$	// fncdDEF_SVCɂĐݒς݂̏ꍇiE_OBJj
	$FOREACH order2 SVC_LIST$
		$IF j < i && SVC.FNCD[order] == SVC.FNCD[order2]$
			$ERROR SVC.TEXT_LINE[order]$E_OBJ: $FORMAT(_("%1% `%2%\' in %3% is duplicated"), "fncd", SVC.FNCD[order], "DEF_SVC")$$END$
		$END$
	$END$

$	// svcatriTA_NULLjłȂꍇiE_RSATRj
	$IF (SVC.SVCATR[order] & ~TARGET_SVCATR) != 0$
		$ERROR SVC.TEXT_LINE[order]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of %3% `%4%\' in %5%"), "svcatr", SVC.SVCATR[order], "fncd", SVC.FNCD[order], "DEF_SVC")$$END$
	$END$

	$svc_order[SVC.FNCD[order]] = order$
	$SVC_LIST = APPEND(SVC_LIST, order)$
$END$

$ @\ԍ̍ől
const FN _kernel_tmax_fncd = TMAX_FNCD;$NL$
$NL$

$ gT[rXR[e[u̐
$IF LENGTH(SVC.ORDER_LIST)$
	const SVCINIB _kernel_svcinib_table[TMAX_FNCD] = {$NL$
	$JOINEACH fncd RANGE(1, tmax_fncd) ",\n"$
		$IF LENGTH(svc_order[fncd])$
			$TAB${ (EXTSVC)($SVC.SVCRTN[svc_order[fncd]]$),
			$SPC$$SVC.STKSZ[svc_order[fncd]]$ }
		$ELSE$
			$TAB${ NULL, 0 }
		$END$
	$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const EXTSVC, _kernel_svcinib_table);$NL$
$END$$NL$

$
$  ^XNReLXgp̃X^bN̈
$
/*$NL$
$SPC$*  Stack Area for Non-task Context$NL$
$SPC$*/$NL$
$NL$

$IF !LENGTH(ICS.ORDER_LIST)$
$	// DEF_ICSȂꍇ̃ftHgl̐ݒ
	#ifdef DEFAULT_ISTK$NL$
	$NL$
	#define TOPPERS_ISTKSZ		DEFAULT_ISTKSZ$NL$
	#define TOPPERS_ISTK		DEFAULT_ISTK$NL$
	$NL$
	#else /* DEAULT_ISTK */$NL$
	$NL$
	$ALLOC_SSTACK("_kernel_istack", "DEFAULT_ISTKSZ")$
	#define TOPPERS_ISTKSZ		ROUND_STK_T(DEFAULT_ISTKSZ)$NL$
	#define TOPPERS_ISTK		_kernel_istack$NL$
	$NL$
	#endif /* DEAULT_ISTK */$NL$
$ELSE$
$	// J[lhC݂̈͂̒ɂȂꍇiE_RSATRj
	$IF !LENGTH(ICS.DOMAIN[1]) || ICS.DOMAIN[1] != TDOM_KERNEL$
		$ERROR ICS.TEXT_LINE[1]$E_RSATR: $FORMAT(_("%1% must be within the kernel domain"), "DEF_ICS")$$END$
	$END$

$	// ÓIAPIuDEF_ICSviE_OBJj
	$IF LENGTH(ICS.ORDER_LIST) > 1$
		$ERROR$E_OBJ: $FORMAT(_("too many %1%"), "DEF_ICS")$$END$
	$END$

$ 	// istkszX^bN̈̃TCYƂĐȂꍇiE_PARj
	$IF !EQ(ICS.ISTK[1], "NULL") && CHECK_STKSZ_ALIGN
							&& (ICS.ISTKSZ[1] & (CHECK_STKSZ_ALIGN - 1))$
		$ERROR ICS.TEXT_LINE[1]$E_PAR: $FORMAT(_("%1% `%2%\' in %3% is not aligned"), "istksz", ICS.ISTKSZ[1], "DEF_ICS")$$END$
	$END$

	$IF EQ(ICS.ISTK[1], "NULL")$
$		// X^bN̈̎t
		$ALLOC_SSTACK("_kernel_istack", ICS.ISTKSZ[1])$
		#define TOPPERS_ISTKSZ		ROUND_STK_T($ICS.ISTKSZ[1]$)$NL$
		#define TOPPERS_ISTK		_kernel_istack$NL$
	$ELSE$
		#define TOPPERS_ISTKSZ		($ICS.ISTKSZ[1]$)$NL$
		#define TOPPERS_ISTK		($ICS.ISTK[1]$)$NL$
	$END$
$END$
$NL$

$ ^XNReLXgp̃X^bN̈
const SIZE		_kernel_istksz = TOPPERS_ISTKSZ;$NL$
STK_T *const	_kernel_istk = TOPPERS_ISTK;$NL$
$NL$
#ifdef TOPPERS_ISTKPT$NL$
STK_T *const	_kernel_istkpt = TOPPERS_ISTKPT(TOPPERS_ISTK, TOPPERS_ISTKSZ);$NL$
#endif /* TOPPERS_ISTKPT */$NL$
$NL$

$
$  ^CCxgǗ
$
/*$NL$
$SPC$*  Time Event Management$NL$
$SPC$*/$NL$
$NL$
TMEVTN   _kernel_tmevt_heap[TNUM_TSKID + TNUM_CYCID + TNUM_ALMID];$NL$
$NL$

$
$  eW[̏֐
$
/*$NL$
$SPC$*  Module Initialization Function$NL$
$SPC$*/$NL$
$NL$
void$NL$
_kernel_initialize_object(void)$NL$
{$NL$
$TAB$_kernel_initialize_task();$NL$
$IF LENGTH(SEM.ID_LIST)$$TAB$_kernel_initialize_semaphore();$NL$$END$
$IF LENGTH(FLG.ID_LIST)$$TAB$_kernel_initialize_eventflag();$NL$$END$
$IF LENGTH(DTQ.ID_LIST)$$TAB$_kernel_initialize_dataqueue();$NL$$END$
$IF LENGTH(PDQ.ID_LIST)$$TAB$_kernel_initialize_pridataq();$NL$$END$
$IF LENGTH(MTX.ID_LIST)$$TAB$_kernel_initialize_mutex();$NL$$END$
$IF LENGTH(MPF.ID_LIST)$$TAB$_kernel_initialize_mempfix();$NL$$END$
$IF LENGTH(CYC.ID_LIST)$$TAB$_kernel_initialize_cyclic();$NL$$END$
$IF LENGTH(ALM.ID_LIST)$$TAB$_kernel_initialize_alarm();$NL$$END$
#ifdef TOPPERS_SUPPORT_OVRHDR$NL$
$TAB$_kernel_initialize_overrun();$NL$
#endif /* TOPPERS_SUPPORT_OVRHDR */$NL$
$TAB$_kernel_initialize_interrupt();$NL$
$TAB$_kernel_initialize_exception();$NL$
}$NL$
$NL$

$
$  [`̎s֐
$
/*$NL$
$SPC$*  Initialization Routine$NL$
$SPC$*/$NL$
$NL$
void$NL$
_kernel_call_inirtn(void)$NL$
{$NL$
$FOREACH order INI.ORDER_LIST$
$	// J[lhC݂̈͂̒ɂȂꍇiE_RSATRj
	$IF !LENGTH(INI.DOMAIN[order]) || INI.DOMAIN[order] != TDOM_KERNEL$
		$ERROR INI.TEXT_LINE[order]$E_RSATR: $FORMAT(_("%1% must be within the kernel domain"), "ATT_INI")$$END$
	$END$

$ 	// iniatriTA_NULLjłȂꍇiE_RSATRj
	$IF INI.INIATR[order] != 0$
		$ERROR INI.TEXT_LINE[order]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of %3% `%4%\' in %5%"), "iniatr", INI.INIATR[order], "inirtn", INI.INIRTN[order], "ATT_INI")$$END$
	$END$
	$TAB$((INIRTN)($INI.INIRTN[order]$))((intptr_t)($INI.EXINF[order]$));$NL$
$END$
}$NL$
$NL$

$
$  I[`̎s֐
$
/*$NL$
$SPC$*  Termination Routine$NL$
$SPC$*/$NL$
$NL$
void$NL$
_kernel_call_terrtn(void)$NL$
{$NL$
$FOREACH rorder TER.RORDER_LIST$
$	// J[lhC݂̈͂̒ɂȂꍇiE_RSATRj
	$IF !LENGTH(TER.DOMAIN[rorder]) || TER.DOMAIN[rorder] != TDOM_KERNEL$
		$ERROR TER.TEXT_LINE[rorder]$E_RSATR: $FORMAT(_("%1% must be within the kernel domain"), "ATT_TER")$$END$
	$END$

$ 	// teratriTA_NULLjłȂꍇiE_RSATRj
	$IF TER.TERATR[rorder] != 0$
		$ERROR TER.TEXT_LINE[rorder]$E_RSATR: $FORMAT(_("illegal %1% `%2%\' of %3% `%4%\' in %5%"), "teratr", TER.TERATR[rorder], "terrtn", TER.TERRTN[rorder], "ATT_TER")$$END$
	$END$
	$TAB$((TERRTN)($TER.TERRTN[rorder]$))((intptr_t)($TER.EXINF[rorder]$));$NL$
$END$
}$NL$
$NL$

$
$  IuWFNgǗ@\
$
/*$NL$
$SPC$*  Memory Object Management Functions$NL$
$SPC$*/$NL$
$NL$

$
$  [UX^bN̈̔zǔ
$
$ MO.STKORDER[moid]F[UX^bN̈zu鏇
$
$IF !USE_REDZONE$
$ 	// bh][łȂꍇɂ́ChCɃ^XNIDɔzuD
	$FOREACH moid MO_USTACK_LIST$
		$MO.STKORDER[moid] = MO.TSKID[moid]$
	$END$
$ELSE$
$ 	// bh][ɂ郆[UX^bN̈̔zǔ
	$IF LENGTH(MO_USTACK_LIST)$
		$INCLUDE "kernel/redzone.tf"$
	$END$
$END$

$
$  ÕIuWFNg̏̉H
$
$ ÕIuWFNg̏ɁCȉ̏ǉȂ͏C
$ D
$
$ MO.MEMATR[moid]FIuWFNg
$	TA_NOWRITEݒ肳Ăꍇ́CTA_MEMINITA_MEMPRSVNA
$ MO.ACPTN1[moid]Fʏ푀1i݁j̃ANZXp^[
$	MO.MEMATR[moid]TA_NOWRITEݒ肳Ăꍇ0ɂD
$ MO.CLASS[moid]FIuWFNgzu邽߂̕ގwWiJ
$				  zuꍇ̂݁j
$	0FW̃IuWFNgCACPTN1ACPTN2W
$	  i^XÑ[UX^bN̈Ɋ܂߂j
$	1FW̃IuWFNgCACPTN1܂ACPTN2WłȂ
$	2FWłȂIuWFNg
$	3FWłȂ[Wւ̔zu
$ MO.SRPW[moid]FL[hLCg̈悩HiJzuꍇ̂݁j
$ MO.STDACPTN4[moid]FMO.ACPTN4[moid]WHiWȂ1j
$
$FOREACH moid RANGE(1, nummo)$
	$domptn = DEFAULT_ACPTN[MO.DOMAIN[moid]]$

	$IF (MO.MEMATR[moid] & TA_NOWRITE) != 0$
		$IF MO.LINKER[moid] && (REG.REGATR[MO.MEMREG[moid]] & TA_NOWRITE) != 0$
			$MO.MEMATR[moid] = MO.MEMATR[moid] & ~(TA_MEMINI|TA_MEMPRSV)$
		$END$
		$MO.ACPTN1[moid] = VALUE("0U", 0)$
	$END$

	$IF MO.LINKER[moid]$
		$MO.SRPW[moid] = 0$
		$IF MO.MEMREG[moid] == STANDARD_ROM$
			$IF (MO.MEMATR[moid] & TA_EXEC) != 0
								&& MO.MEMATR[moid] != MEMATR_TEXT
				|| (MO.MEMATR[moid] & TA_EXEC) == 0
								&& MO.MEMATR[moid] != MEMATR_RODATA$
				$MO.CLASS[moid] = 2$
			$ELIF MO.ACPTN2[moid] != domptn$
				$MO.CLASS[moid] = 1$
			$ELSE$
				$MO.CLASS[moid] = 0$
			$END$
		$ELIF MO.MEMREG[moid] == STANDARD_RAM$
			$IF MO.TYPE[moid] == TOPPERS_USTACK$
				$MO.CLASS[moid] = 0$
			$ELIF (MO.MEMATR[moid] & TA_MEMINI) != 0
								&& MO.MEMATR[moid] != MEMATR_DATA
				|| (MO.MEMATR[moid] & TA_MEMPRSV) != 0
								&& MO.MEMATR[moid] != MEMATR_PRSV
				|| (MO.MEMATR[moid] & (TA_MEMINI|TA_MEMPRSV)) == 0
								&& MO.MEMATR[moid] != MEMATR_BSS$
				$MO.CLASS[moid] = 2$
			$ELIF MO.ACPTN1[moid] != domptn$
				$MO.CLASS[moid] = 1$
			$ELIF MO.ACPTN2[moid] != domptn$
				$MO.CLASS[moid] = 1$
				$IF MO.ACPTN2[moid] == TACP_SHARED$
					$MO.SRPW[moid] = 1$
				$END$
			$ELSE$
				$MO.CLASS[moid] = 0$
			$END$
		$ELSE$
			$MO.CLASS[moid] = 3$
		$END$
	$END$

	$IF MO.ACPTN4[moid] == domptn$
		$MO.STDACPTN4[moid] = 1$
	$ELSE$
		$MO.STDACPTN4[moid] = 0$
	$END$
$END$

$
$  ÕIuWFNg\[g邽߂̔z
$
$ MO.ORDER[moid]FIuWFNg\[g邽߂1wW
$ MO.MEMATR1[moid]F\[gۂɁCACPTN1CACPTN2ɗp鑮
$ MO.MEMATR2[moid]F\[gۂɁCACPTN1CACPTN2ɗp鑮
$
$FOREACH moid RANGE(1, nummo)$
$	// ܂C[Wԍ̏Ƀ\[gD
	$IF MO.LINKER[moid]$
		$memreg = MO.MEMREG[moid]$
	$ELSE$
$		// JzuȂ̂́CŌɂD
		$memreg = LENGTH(REG.ORDER_LIST) + 1$
	$END$
	$order = memreg$

$	// ɁCیhCɂă\[gD
	$IF MO.TYPE[moid] == TOPPERS_USTACK$
$		// [UX^bN̈́CJ[lhC̒ɔzuD
		$type = 1$
$		// bh][łȂꍇ́CیhCID̏ɔzuD
		$IF !USE_REDZONE$
			$domain = MO.DOMAIN[moid] - 1$
		$END$
	$ELIF MO.DOMAIN[moid] == TDOM_KERNEL$
$		// J[lhC͍ŏɔzuD
		$type = 0$
		$domain = 0$
	$ELIF MO.DOMAIN[moid] == TDOM_NONE$
$		// ͍ŌɔzuD
		$type = 4$
		$domain = 0$
	$ELSE$
$		// [UhĆCیhCID̏ɔzuD
		$domain = MO.DOMAIN[moid] - 1$
		$IF LENGTH(MO.SRPW[moid]) && MO.SRPW[moid]$
$			// L[hLCg̈́C[UhČ
$			// ܂Ƃ߂ĔzuD
			$type = 3$
		$ELSE$
			$type = 2$
		$END$
	$END$
	$order = (order << 3) + type$
	$order = (order << 5) + domain$

$	// ɁCIuWFNgzu邽߂̕ގwWɂĔzuD
	$class = 0$
	$IF MO.LINKER[moid] && MO.TYPE[moid] != TOPPERS_USTACK$
		$IF MO.MEMREG[moid] == STANDARD_ROM$
			$IF MO.DOMAIN[moid] == TDOM_NONE$
$				// WROM[Ẃ̖CCLASS̋tɔzuD
				$class = 3 - MO.CLASS[moid]$
			$ELSE$
$				// J[lhCƃ[UhĆCCLASS̏ɔzuD
				$class = MO.CLASS[moid]$
			$END$
		$ELIF MO.MEMREG[moid] == STANDARD_RAM$
			$IF MO.DOMAIN[moid] == TDOM_KERNEL || MO.DOMAIN[moid] == TDOM_NONE$
$				// WRAM[W̃J[lhCƖ́C
$				// CLASS̋tɔzuD
				$class = 3 - MO.CLASS[moid]$
			$ELSE$
$				// [UhĆCCLASS̏ɔzuD
				$class = MO.CLASS[moid]$
			$END$
		$END$
	$END$
	$order = (order << 2) + class$

$	// ʂMO.ORDER[moid]Ɋi[
	$MO.ORDER[moid] = order$

$	// MO.MEMATR1[moid]MO.MEMATR2[moid]ݒ肷
	$IF MO.LINKER[moid]$
		$IF (REG.REGATR[MO.MEMREG[moid]] & TA_NOWRITE) != 0$
			$MO.MEMATR1[moid] = MO.MEMATR[moid] & ~TA_EXEC$
			$MO.MEMATR2[moid] = MO.MEMATR[moid] & TA_EXEC$
$			// TA_EXECݒ肳ĂOɔzu
			$MO.MEMATR2[moid] = MO.MEMATR2[moid] ^ TA_EXEC$
		$ELSE$
			$MO.MEMATR1[moid] = MO.MEMATR[moid] & ~(TA_MEMINI|TA_MEMPRSV)$
			$MO.MEMATR2[moid] = MO.MEMATR[moid] & (TA_MEMINI|TA_MEMPRSV)$
$			// TA_MEMINIݒ肳ĂOɔzu
			$MO.MEMATR2[moid] = MO.MEMATR2[moid] ^ TA_MEMINI$
		$END$
	$END$
$END$

$
$  IuWFNg\[g邽߂̔r֐
$
$IF !ISFUNCTION("MO_COMPARE")$
$FUNCTION MO_COMPARE$
$	܂́CMO.ORDERŔrD
	$RESULT = MO.ORDER[ARGV[1]] - MO.ORDER[ARGV[2]]$
	$IF (RESULT == 0) && MO.LINKER[ARGV[1]]$
$		// MO.ORDERŁCJ̔zuΏۂ̏ꍇ́AɃ\[gD
		$_moid1 = ARGV[1]$
		$_moid2 = ARGV[2]$
		$IF MO.TYPE[_moid1] == TOPPERS_USTACK$
$			// [UX^bN̈̏ꍇ
$			// MO.STKORDERŃ\[gD
			$RESULT = MO.STKORDER[_moid1] - MO.STKORDER[_moid2]$
		$ELIF MO.MEMATR1[_moid1] != MO.MEMATR1[_moid2]$
$			// MO.MEMATR1قȂ΁CŃ\[gD
			$RESULT = MO.MEMATR1[_moid1] - MO.MEMATR1[_moid2]$
		$ELIF MO.ACPTN1[_moid1] != MO.ACPTN1[_moid2]$
$			// MO.ACPTN1قȂ΁CŃ\[gD
			$RESULT = MO.ACPTN1[_moid1] - MO.ACPTN1[_moid2]$
		$ELIF MO.ACPTN2[_moid1] != MO.ACPTN2[_moid2]$
$			// MO.ACPTN2قȂ΁CŃ\[gD
			$RESULT = MO.ACPTN2[_moid1] - MO.ACPTN2[_moid2]$
		$ELIF MO.MEMATR2[_moid1] != MO.MEMATR2[_moid2]$
$			// MO.MEMATR2قȂ΁CŃ\[gD
			$RESULT = MO.MEMATR2[_moid1] - MO.MEMATR2[_moid2]$
		$ELIF MO.ACPTN4[_moid1] == MO.ACPTN4[_moid2]$
$			// MO.ACPTN4ł΁Cňȏ\[gȂD
			$RESULT = 0$
		$ELIF MO.STDACPTN4[_moid1]$
			$IF MO.DOMAIN[_moid1] != TDOM_NONE$
$				// ȊOł́CWACPTN4̂ɔzuD
				$RESULT = -1$
			$ELSE$
$				// ł́CWACPTN4̂ɔzuD
				$RESULT = 1$
			$END$
		$ELIF MO.STDACPTN4[_moid2]$
			$IF MO.DOMAIN[_moid1] != TDOM_NONE$
$				// ȊOł́CWACPTN4̂ɔzuD
				$RESULT = 1$
			$ELSE$
$				// ł́CWACPTN4̂ɔzuD
				$RESULT = -1$
			$END$
		$ELSE$
$			// ǂWłȂꍇ́CMO.MEMATR4Ń\[gD
			$RESULT = MO.ACPTN4[_moid1] - MO.ACPTN4[_moid2]$
		$END$
	$END$
$END$
$END$

$
$  IuWFNg̃\[g
$
$ ŏMO.ORDERŃ\[gĂƂŁCMO_COMPAREg\[g
$ 邱Ƃ҂ĂD
$
$MO_ORDER = SORT(RANGE(1, nummo), "MO.ORDER")$
$MO_ORDER = LSORT(MO_ORDER, "MO_COMPARE")$

$
$  IuWFNg̓
$
$ MO.SEFLAG[moid]Fȉ̃rbg̃rbg_aɐݒ肷D
$	0x01FZNV̐擪
$	0x02FZNV̍Ō
$	0x04FIuWFNg̐擪
$	0x08FIuWFNg̍Ō
$	0x10FیPʂ̐擪
$	0x20FیPʂ̍Ō
$	0x40F[W̐擪
$	0x80F[W̍Ō
$	0x100FL[hpCg̈Ŝ̐擪
$	0x200FL[hpCg̈Ŝ̍Ō
$ MO_SECTION_LISTFZNV̐擪̃Xg
$ MO_START_LISTFIuWFNg̐擪̃Xg
$ MO_MPROTECT_LISTFیPʂ̐擪̃Xg
$
$MO_SECTION_LIST = {}$
$MO_START_LIST = {}$
$MO_MPROTECT_LIST = {}$
$i = 0$
$FOREACH moid MO_ORDER$
	$IF i == 0$
		$MO.SEFLAG[moid] = 0x15$
		$IF MO.LINKER[moid]$
			$MO.SEFLAG[moid] = MO.SEFLAG[moid] | 0x40$
		$END$
	$ELSE$
		$IF MO.ORDER[moid] != MO.ORDER[prev_moid]
				|| (MO.TYPE[moid] & TOPPERS_ATTSEC) == 0
				|| (MO.TYPE[prev_moid] & TOPPERS_ATTSEC) == 0
				|| (MO.MEMATR[moid] & ~(TA_MEMINI|TA_MEMPRSV))
						!= (MO.MEMATR[prev_moid] & ~(TA_MEMINI|TA_MEMPRSV))
				|| MO.ACPTN1[moid] != MO.ACPTN1[prev_moid]
				|| MO.ACPTN2[moid] != MO.ACPTN2[prev_moid]$
			$MO.SEFLAG[moid] = 0x15$
			$MO.SEFLAG[prev_moid] = MO.SEFLAG[prev_moid] | 0x2a$
		$ELIF MO.MEMATR[moid] != MO.MEMATR[prev_moid]$
			$MO.SEFLAG[moid] = 0x05$
			$MO.SEFLAG[prev_moid] = MO.SEFLAG[prev_moid] | 0x0a$
		$ELIF MO.ACPTN4[moid] != MO.ACPTN4[prev_moid]$
			$MO.SEFLAG[moid] = 0x04$
			$MO.SEFLAG[prev_moid] = MO.SEFLAG[prev_moid] | 0x08$
		$ELSE$
			$MO.SEFLAG[moid] = 0$
		$END$

		$IF MO.LINKER[prev_moid] && MO.LINKER[moid]
					&& MO.MEMREG[prev_moid] != MO.MEMREG[moid]$
			$MO.SEFLAG[moid] = MO.SEFLAG[moid] | 0x40$
			$MO.SEFLAG[prev_moid] = MO.SEFLAG[prev_moid] | 0x80$
		$ELIF MO.LINKER[prev_moid] && !MO.LINKER[moid]$
			$MO.SEFLAG[prev_moid] = MO.SEFLAG[prev_moid] | 0x80$
		$END$

		$IF !(MO.LINKER[prev_moid] && MO.SRPW[prev_moid])
					&& (MO.LINKER[moid] && MO.SRPW[moid])$
			$MO.SEFLAG[moid] = MO.SEFLAG[moid] | 0x100$
		$END$
		$IF (MO.LINKER[prev_moid] && MO.SRPW[prev_moid])
					&& !(MO.LINKER[moid] && MO.SRPW[moid])$
			$MO.SEFLAG[prev_moid] = MO.SEFLAG[prev_moid] | 0x200$
		$END$
	$END$

$	// MO_SECTION_LISTCMO_START_LISTCMO_MPROTECT_LISTւ̒ǉ
	$IF (MO.SEFLAG[moid] & 0x01) !=0$
		$MO_SECTION_LIST = APPEND(MO_SECTION_LIST, moid)$
	$END$
	$IF (MO.SEFLAG[moid] & 0x04) !=0$
		$MO_START_LIST = APPEND(MO_START_LIST, moid)$
	$END$
	$IF (MO.SEFLAG[moid] & 0x10) !=0$
		$MO_MPROTECT_LIST = APPEND(MO_MPROTECT_LIST, moid)$
	$END$

	$prev_moid = moid$
	$i = i + 1$
$END$
$MO.SEFLAG[prev_moid] = MO.SEFLAG[prev_moid] | 0x2a$
$IF MO.LINKER[prev_moid]$
	$MO.SEFLAG[prev_moid] = MO.SEFLAG[prev_moid] | 0x80$
$END$
$IF MO.LINKER[prev_moid] && MO.SRPW[prev_moid]$
	$MO.SEFLAG[prev_moid] = MO.SEFLAG[prev_moid] | 0x200$
$END$

$
$  IuWFNg̃x̐
$
$ MO.SLABEL[moid]FZNṼx
$ MO.ILABEL[moid]Ff[^̈̃x
$ MO.MLABEL[moid]FIuWFNg̃x
$ MO.PLABEL[moid]FیPʂ̃x
$ DATASEC_LISTFdataZNṼXg
$ BSSSEC_LISTFbssZNṼXg
$
$DATASEC_LIST = {}$
$BSSSEC_LIST = {}$
$FOREACH moid MO_ORDER$
	$IF MO.LINKER[moid]$
		$domlabel = DOM.LABEL[MO.DOMAIN[moid]]$
		$IF (REG.REGATR[MO.MEMREG[moid]] & TA_NOWRITE) != 0$
			$IF (MO.MEMATR[moid] & TA_EXEC) != 0$
				$typelabel = "text"$
			$ELSE$
				$typelabel = "rodata"$
			$END$
			$acptn12 = FORMAT("%x", +MO.ACPTN2[moid])$
			$plabel = ""$
		$ELSE$
			$IF (MO.MEMATR[moid] & TA_MEMINI) != 0$
				$typelabel = "data"$
				$IF (MO.SEFLAG[moid] & 0x01) != 0$
					$DATASEC_LIST = APPEND(DATASEC_LIST, moid)$
				$END$
			$ELIF (MO.MEMATR[moid] & TA_MEMPRSV) != 0$
				$typelabel = "prsv"$
			$ELSE$
				$typelabel = "bss"$
				$IF (MO.SEFLAG[moid] & 0x01) != 0$
					$BSSSEC_LIST = APPEND(BSSSEC_LIST, moid)$
				$END$
			$END$
			$acptn12 = FORMAT("%x_%x", +MO.ACPTN1[moid], +MO.ACPTN2[moid])$
			$plabel = FORMAT("%s_%s", "ram", domlabel)$
		$END$
		$label = FORMAT("%s_%s", typelabel, domlabel)$
		$IF EQ(typelabel, "data")$
			$ilabel = FORMAT("idata_%s", domlabel)$
		$ELSE$
			$ilabel = ""$
		$END$

		$IF MO.TYPE[moid] == TOPPERS_USTACK$
			$MO.SLABEL[moid] = REGEX_REPLACE(MO.SECTION[moid], "\\.", "")$
			$MO.MLABEL[moid] = REGEX_REPLACE(MO.SECTION[moid], "\\.", "")$
			$MO.PLABEL[moid] = ""$
		$ELIF MO.CLASS[moid] == 0$
			$MO.SLABEL[moid] = label$
			$IF !EQ(ilabel, "")$
				$MO.ILABEL[moid] = ilabel$
			$END$
			$IF MO.STDACPTN4[moid]$
				$MO.MLABEL[moid] = FORMAT("%s__std", label)$
			$ELSE$
				$MO.MLABEL[moid] = FORMAT("%s__%x", label, +MO.ACPTN4[moid])$
			$END$
			$IF !EQ(plabel, "")$
				$MO.PLABEL[moid] = plabel$
			$END$
		$ELIF MO.CLASS[moid] == 1$
			$MO.SLABEL[moid] = FORMAT("%s_%s", label, acptn12)$
			$IF !EQ(ilabel, "")$
				$MO.ILABEL[moid] = FORMAT("%s_%s", ilabel, acptn12)$
			$END$
			$MO.MLABEL[moid] = FORMAT("%s__%s_%x", label,
												acptn12, +MO.ACPTN4[moid])$
			$IF !EQ(plabel, "")$
				$MO.PLABEL[moid] = FORMAT("%s_%s", plabel, acptn12)$
			$END$
		$ELIF MO.CLASS[moid] == 2$
			$MO.SLABEL[moid] = FORMAT("%s_%x_%s", label,
												+MO.MEMATR[moid], acptn12)$
			$IF !EQ(ilabel, "")$
				$MO.ILABEL[moid] = FORMAT("%s_%x_%s", ilabel,
												+MO.MEMATR[moid], acptn12)$
			$END$
			$MO.MLABEL[moid] = FORMAT("%s__%x_%s_%x", label,
								+MO.MEMATR[moid], acptn12, +MO.ACPTN4[moid])$
			$IF !EQ(plabel, "")$
				$MO.PLABEL[moid] = FORMAT("%s_%x_%s", plabel,
						MO.MEMATR[moid] & ~(TA_MEMINI|TA_MEMPRSV), acptn12)$
			$END$
		$ELSE$
			$regname = REG.REGNAME[MO.MEMREG[moid]]$
			$MO.SLABEL[moid] = FORMAT("%s_%s_%x_%s", regname, label,
												+MO.MEMATR[moid], acptn12)$
			$IF !EQ(ilabel, "")$
				$MO.ILABEL[moid] = FORMAT("%s_%s_%x_%s", regname, ilabel,
												+MO.MEMATR[moid], acptn12)$
			$END$
			$MO.MLABEL[moid] = FORMAT("%s_%s__%x_%s_%x", regname, label,
								+MO.MEMATR[moid], acptn12, +MO.ACPTN4[moid])$
			$IF !EQ(plabel, "")$
				$MO.PLABEL[moid] = FORMAT("%s_%s_%x_%s", regname, plabel,
						MO.MEMATR[moid] & ~(TA_MEMINI|TA_MEMPRSV), acptn12)$
			$END$
		$END$
	$END$
$END$

$
$  IuWFNgubN̐
$
$IF !OMIT_STANDARD_MEMINIB$
	$FILE "kernel_mem2.c"$

	$FOREACH moid MO_START_LIST$
		$IF MO.LINKER[moid]$
			extern char __start_$MO.MLABEL[moid]$;$NL$
			extern char __limit_$MO.MLABEL[moid]$;$NL$
		$END$
	$END$$NL$

	$tnum_meminib = LENGTH(MO_START_LIST) * 2 + 1$
	const uint_t _kernel_tnum_meminib = $tnum_meminib$U;$NL$
	$NL$

	void *const _kernel_memtop_table[$tnum_meminib$] = {$NL$
	$TAB$0,$NL$
	$JOINEACH moid MO_START_LIST ",\n"$
		$IF MO.LINKER[moid]$
			$TAB$&__start_$MO.MLABEL[moid]$,$NL$
			$TAB$&__limit_$MO.MLABEL[moid]$
		$ELSE$
			$TAB$(void *)($MO.BASE[moid]$),$NL$
			$TAB$(void *)(((char *)($MO.BASE[moid]$)) + ($MO.SIZE[moid]$))
		$END$
	$END$$NL$
	};$NL$
	$NL$

	const MEMINIB _kernel_meminib_table[$tnum_meminib$] = {$NL$
	$TAB${ TA_NULL, 0, 0, 0 },$NL$
	$JOINEACH moid MO_START_LIST ",\n"$
		$TAB${
		$IF MO.TYPE[moid] == TOPPERS_USTACK$
			$SPC$TOPPERS_USTACK|($MO.MEMATR[moid]$),
			$SPC$$MO.ACPTN4[moid]$,
			$IF MO.TSKID[moid] != 0$
				$SPC$(ACPTN)(&_kernel_tcb_table[$MO.TSKID[moid]$ - 1]),
			$ELSE$
				$SPC$(ACPTN)(NULL),
			$END$
			$SPC$0
		$ELSE$
			$IF MO.TYPE[moid] == TOPPERS_ATTMEM$
				$SPC$TOPPERS_ATTMEM|($MO.MEMATR[moid]$),
			$ELSE$
				$SPC$TOPPERS_ATTSEC|($MO.MEMATR[moid]$),
			$END$
			$SPC$$MO.ACPTN4[moid]$,
			$SPC$$MO.ACPTN1[moid]$,
			$SPC$$MO.ACPTN2[moid]$
		$END$
		$SPC$},$NL$
		$TAB${ TA_NULL, 0, 0, 0 }
	$END$$NL$
	};$NL$
	$NL$
$END$

$FILE "kernel_cfg.c"$

$
$  dataZNVubN̐
$
/*$NL$
$SPC$*  Data Section Management Functions$NL$
$SPC$*/$NL$
$NL$

$ dataZNVubNŎgV{extern錾
$IF !OMIT_IDATA$
	$IF LENGTH(DATASEC_LIST)$
		$FOREACH moid DATASEC_LIST$
			extern char __start_$MO.SLABEL[moid]$;$NL$
			extern char __end_$MO.SLABEL[moid]$;$NL$
			extern char __start_$MO.ILABEL[moid]$;$NL$
		$END$$NL$
	$END$
$END$

$	// dataZNV̐
#define TNUM_DATASEC	$IF !OMIT_IDATA$$LENGTH(DATASEC_LIST)$$ELSE$0$END$$NL$
const uint_t _kernel_tnum_datasec = TNUM_DATASEC;$NL$
$NL$

$	// dataZNVubN
$IF !OMIT_IDATA$
	$IF LENGTH(DATASEC_LIST)$
		const DATASECINIB _kernel_datasecinib_table[TNUM_DATASEC] = {$NL$
		$JOINEACH moid DATASEC_LIST ",\n"$
			$TAB${ &__start_$MO.SLABEL[moid]$, &__end_$MO.SLABEL[moid]$, 
			&__start_$MO.ILABEL[moid]$ }
		$END$$NL$
		};$NL$
		$NL$
	$END$
$ELSE$
	TOPPERS_EMPTY_LABEL(const DATASECINIB, _kernel_datasecinib_table);$NL$
	$NL$
$END$

$
$  bssZNVubN̐
$
/*$NL$
$SPC$*  BSS Section Management Functions$NL$
$SPC$*/$NL$
$NL$

$ bssZNVubNŎgV{extern錾
$IF LENGTH(BSSSEC_LIST)$
	$FOREACH moid BSSSEC_LIST$
		extern char __start_$MO.SLABEL[moid]$;$NL$
		extern char __end_$MO.SLABEL[moid]$;$NL$
	$END$$NL$
$END$

$ bssZNV̐
#define TNUM_BSSSEC	$LENGTH(BSSSEC_LIST)$$NL$
const uint_t _kernel_tnum_bsssec = TNUM_BSSSEC;$NL$
$NL$

$ bssZNVubN
$IF LENGTH(BSSSEC_LIST)$
	const BSSSECINIB _kernel_bsssecinib_table[TNUM_BSSSEC] = {$NL$
	$JOINEACH moid BSSSEC_LIST ",\n"$
		$TAB${ &__start_$MO.SLABEL[moid]$, &__end_$MO.SLABEL[moid]$ }
	$END$$NL$
	};$NL$
	$NL$
$END$




$ //HEWpŒ蒷v[t@C𐶐

$memsize = 0$
$FOREACH moid MO_ORDER$
	$IF EQ(MO.MEMATR[moid],"TA_MEMPRSV")$
		$FOREACH mpfid MPF.ID_LIST$
$			// Œ蒷v[̈
			$IF EQ(MPF.MPF[mpfid], "NULL")$
				$IF LENGTH(MPF.DOMAIN[mpfid]) && (MPF.DOMAIN[mpfid] == TDOM_KERNEL)
						&& (!LENGTH(MPF.ACPTN1[mpfid]) || 
								(MPF.ACPTN1[mpfid] == TACP_KERNEL
									&& MPF.ACPTN2[mpfid] == TACP_KERNEL
									&& MPF.ACPTN4[mpfid] == TACP_KERNEL))$
					$mohew = 0$
				$ELSE$
					$mohew = MPF.HEW[mpfid]$
					$IF mohew == moid$
						$FILE "mpf.c"$
						$ALLOC_UMPF_1(mpfid, MO.MLABEL[moid], MPF.BLKCNT[mpfid], MPF.BLKSZ[mpfid])$
					$END$
				$END$
			$END$
		$END$
	$END$
$END$

$FILE "kernel_cfg.c"$

$ =====================================================================
$  pX3ɓn̐
$ =====================================================================

$FILE "cfg2_out.tf"$
$$ cfg2_out.tf$NL$
$NL$

$ STANDARD_ROMCSTANDARD_RAM̏o
$$STANDARD_ROM = $STANDARD_ROM$$$$NL$
$$STANDARD_RAM = $STANDARD_RAM$$$$NL$
$NL$

$ REG_ORDEȐo
$$REG_ORDER = { $REG_ORDER$ }$$$NL$
$NL$

$ REG.*̏o
$FOREACH reg REG.ORDER_LIST$
	$$REG.REGNAME[$reg$] = $REG.REGION[reg]$$$$NL$
	$$REG.REGATR[$reg$] = VALUE($ESCSTR(REG.REGATR[reg])$,
									$SPC$$+REG.REGATR[reg]$)$$$NL$
	$$REG.BASE[$reg$] = VALUE($ESCSTR(REG.BASE[reg])$,
									$SPC$$+REG.BASE[reg]$)$$$NL$
	$$REG.SIZE[$reg$] = VALUE($ESCSTR(REG.SIZE[reg])$,
									$SPC$$+REG.SIZE[reg]$)$$$NL$
	$NL$
$END$

$ MO_ORDERCMO_SECTION_LISTCMO_START_LISTCMO_MPROTECT_LIST̏o
$$MO_ORDER = { $MO_ORDER$ }$$$NL$
$NL$
$$MO_SECTION_LIST = { $MO_SECTION_LIST$ }$$$NL$
$NL$
$$MO_START_LIST = { $MO_START_LIST$ }$$$NL$
$NL$
$$MO_MPROTECT_LIST = { $MO_MPROTECT_LIST$ }$$$NL$
$NL$

$ MO.*̏o
$FOREACH moid MO_ORDER$
	$$MO.TYPE[$moid$] = $MO.TYPE[moid]$$$$NL$
	$IF MO.TYPE[moid] == TOPPERS_ATTMOD$
		$$MO.MODULE[$moid$] = $ESCSTR(MO.MODULE[moid])$$$$NL$
	$ELIF MO.TYPE[moid] == TOPPERS_ATTMEM$
		$$MO.BASE[$moid$] = $ESCSTR(MO.BASE[moid])$$$$NL$
		$$MO.SIZE[$moid$] = $ESCSTR(MO.SIZE[moid])$$$$NL$
		$IF LENGTH(MO.PADDR[moid])$
			$$MO.PADDR[$moid$] = VALUE($ESCSTR(MO.PADDR[moid])$,
									$SPC$$+MO.PADDR[moid]$)$$$NL$
		$END$
	$ELIF MO.TYPE[moid] == TOPPERS_USTACK$
		$$MO.TSKID[$moid$] = VALUE($ESCSTR(MO.TSKID[moid])$,
									$SPC$$+MO.TSKID[moid]$)$$$NL$
		$IF !MO.LINKER[moid]$
			$$MO.BASE[$moid$] = $ESCSTR(MO.BASE[moid])$$$$NL$
		$END$
		$$MO.SIZE[$moid$] = $ESCSTR(MO.SIZE[moid])$$$$NL$
		$IF LENGTH(MO.STKORDER[moid])$
			$$MO.STKORDER[$moid$] = $+MO.STKORDER[moid]$$$$NL$
		$END$
	$ELIF MO.TYPE[moid] == TOPPERS_MPFAREA$
		$$MO.MPFID[$moid$] = VALUE($ESCSTR(MO.MPFID[moid])$,
									$SPC$$+MO.MPFID[moid]$)$$$NL$
	$END$
	$$MO.LINKER[$moid$] = $MO.LINKER[moid]$$$$NL$
	$$MO.DOMAIN[$moid$] = VALUE($ESCSTR(MO.DOMAIN[moid])$,
									$SPC$$+MO.DOMAIN[moid]$)$$$NL$
	$IF MO.LINKER[moid]$
		$$MO.MEMREG[$moid$] = $MO.MEMREG[moid]$$$$NL$
		$$MO.SECTION[$moid$] = $ESCSTR(MO.SECTION[moid])$$$$NL$
		$$MO.CLASS[$moid$] = $MO.CLASS[moid]$$$$NL$
		$$MO.SRPW[$moid$] = $MO.SRPW[moid]$$$$NL$
		$$MO.MEMATR1[$moid$] = $MO.MEMATR1[moid]$$$$NL$
		$$MO.MEMATR2[$moid$] = $MO.MEMATR2[moid]$$$$NL$
	$END$
	$$MO.MEMATR[$moid$] = VALUE($ESCSTR(MO.MEMATR[moid])$,
									$SPC$$+MO.MEMATR[moid]$)$$$NL$
	$$MO.ACPTN1[$moid$] = VALUE($ESCSTR(MO.ACPTN1[moid])$,
									$SPC$$+MO.ACPTN1[moid]$)$$$NL$
	$$MO.ACPTN2[$moid$] = VALUE($ESCSTR(MO.ACPTN2[moid])$,
									$SPC$$+MO.ACPTN2[moid]$)$$$NL$
	$$MO.ACPTN4[$moid$] = VALUE($ESCSTR(MO.ACPTN4[moid])$,
									$SPC$$+MO.ACPTN4[moid]$)$$$NL$
	$IF LENGTH(MO.TEXT_LINE[moid])$
		$$MO.TEXT_LINE[$moid$] = VALUE($ESCSTR(MO.TEXT_LINE[moid])$,
									$SPC$$+MO.TEXT_LINE[moid]$)$$$NL$
	$END$
	$$MO.STDACPTN4[$moid$] = $MO.STDACPTN4[moid]$$$$NL$
	$$MO.ORDER[$moid$] = $MO.ORDER[moid]$$$$NL$
	$$MO.SEFLAG[$moid$] = 0x$FORMAT("%x", +MO.SEFLAG[moid])$$$$NL$
	$$MO.SLABEL[$moid$] = $ESCSTR(MO.SLABEL[moid])$$$$NL$
	$$MO.ILABEL[$moid$] = $ESCSTR(MO.ILABEL[moid])$$$$NL$
	$$MO.MLABEL[$moid$] = $ESCSTR(MO.MLABEL[moid])$$$$NL$
	$$MO.PLABEL[$moid$] = $ESCSTR(MO.PLABEL[moid])$$$$NL$
	$NL$
$END$

$ LNKSEC.*̏o
$$numls = $numls$$$$NL$
$FOREACH lsid RANGE(1, numls)$
	$$LNKSEC.MEMREG[$lsid$] = $LNKSEC.MEMREG[lsid]$$$$NL$
	$$LNKSEC.SECTION[$lsid$] = $ESCSTR(LNKSEC.SECTION[lsid])$$$$NL$
	$NL$
$END$

$FILE "kernel_cfg.c"$
