$ ======================================================================
$
$   TOPPERS/HRP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       High Reliable system Profile Kernel
$
$   Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$  
$   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
$   Ai{\tgEFAς̂܂ށDȉjgpEE
$   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
$   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
$       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
$       XR[hɊ܂܂Ă邱ƁD
$   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
$       pł`ōĔzzꍇɂ́CĔzzɔhLgip
$       ҃}jAȂǁjɁCL̒쌠\C̗pщL
$       ̖ۏ؋Kfڂ邱ƁD
$   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
$       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
$       ƁD
$     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
$         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
$     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
$         񍐂邱ƁD
$   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
$       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
$       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
$       RɊÂCL쌠҂TOPPERSvWFNg
$       Ɛӂ邱ƁD
$  
$   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
$   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
$   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
$   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
$   ̐ӔC𕉂ȂD
$
$ =====================================================================

$INCLUDE "kernel/kernel_mem.tf"$

$FILE "kernel_mem.c"$

$ 
$  یhC̃ftHg̃ANZXp^[̍쐬
$ 
$DEFAULT_ACPTN[TDOM_KERNEL] = VALUE("TACP_KERNEL", TACP_KERNEL)$
$FOREACH domid DOM.ID_LIST$
	$DEFAULT_ACPTN[domid] = VALUE(FORMAT("TACP(%1%)", domid), 1 << (domid - 1))$
$END$
$DEFAULT_ACPTN[TDOM_NONE] = VALUE("TACP_SHARED", TACP_SHARED)$

$ 
$  y[We[ȕ𐶐
$  y[W̕ی쑮o͂
$ 
$  J[lhC̃y[We[u쐬

const uint32_t page_table_info_kernel[$tsize_meminib$] = {$NL$
$IF !LENGTH(suppresszero)$
    $TAB$(uint32_t)0x0U,$NL$
$END$
$JOINEACH moid MO_MEMTOP_ORDER ",\n"$
    $page_table_entry = 0$
    $page_mp_info = 0$
    $IF !LENGTH(MO.SUPPRESSSTART[moid])$
        $IF MO.TYPE[moid] != TOPPERS_USTACK$
$           // [UX^bNȊO
            $page_table_entry = 0x00000000$

$           // LԃrbgZbg
$           // ̃IuWFNgȂ΋Lԃrbg𗧂Ă
            $IF (MO.ACPTN2[moid] == DEFAULT_ACPTN[TDOM_NONE])$
                $IF (((MO.MEMATR[moid] & TA_NOWRITE) != 0) || ((MO.ACPTN1[moid] == DEFAULT_ACPTN[TDOM_NONE])))$
                    $page_table_entry = page_table_entry | (0x01 << 1)$
                $END$
            $END$

$           // یL[f[^̈Zbg
            $IF (MO.MEMATR[moid] & TA_NOWRITE) == 0$
                $IF (page_table_entry & 0x02) == 0$
$                   // [hRWX\
                    $page_table_entry = page_table_entry | (0x01 << 5)$
                $ELSE$
$                   // [U[hRWX\
                    $page_table_entry = page_table_entry | (0x03 << 5)$
                $END$
            $ELSE$
                $IF (page_table_entry & 0x02) == 0$
$                   // [hRX\
                    $page_table_entry = page_table_entry | (0x00 << 5)$
                $ELSE$
$                   // [U[hRX\
                    $page_table_entry = page_table_entry | (0x02 << 5)$
                $END$
            $END$

$           // y[WTCYrbgZbg
$           // ׂ4KB
            $page_table_entry = page_table_entry | (0x01 << 4)$

$           // LbVO\rbgZbg
            $IF (MO.MEMATR[moid] & TA_UNCACHE) == 0$
                $page_table_entry = page_table_entry | (0x01 << 3)$
            $END$
$           // CgX[rbgZbg
$            $page_table_entry = page_table_entry | (0x01 << 0)$

$           // _[eBrbgZbg
            $page_table_entry = page_table_entry | (0x01 << 2)$

$           // LrbgZbg
            $page_table_entry = page_table_entry | (0x01 << 8)$

            $page_table_entry = VALUE("", +page_table_entry)$
            $TAB$(uint32_t)$FORMAT("0x%xU", +page_table_entry)$
        $ELSE$
$           // [UX^bN
$           // CgX[
$            $TAB$(uint32_t)$FORMAT("0x0000017dU")$
$           // CgobN
            $TAB$(uint32_t)$FORMAT("0x0000017cU")$
$           // LbVOs
$            $TAB$(uint32_t)$FORMAT("0x00000174U")$
        $END$
    $END$
    $IF !LENGTH(MO.SUPPRESSLIMIT[moid])$
        $IF !LENGTH(MO.SUPPRESSSTART[moid])$,$NL$$END$
        $TAB$(uint32_t)0x0U
    $END$
$END$
$NL$};$NL$$NL$

$  [UhCƂɃy[We[u쐬
$IF LENGTH(DOM.ID_LIST) > 0$
    $FOREACH domid DOM.ID_LIST$
        const uint32_t page_table_info_$domid - 1$[$tsize_meminib$] = {$NL$
        $IF !LENGTH(suppresszero)$
            $TAB$(uint32_t)0x0U,$NL$
        $END$
        $JOINEACH moid MO_MEMTOP_ORDER ",\n"$
            $page_table_entry = 0$
            $page_mp_info = 0$
            $IF !LENGTH(MO.SUPPRESSSTART[moid])$
                $IF MO.TYPE[moid] != TOPPERS_USTACK$
$                   // [UX^bN̈łȂꍇPTELWX^ɏޒl
$                   // [UX^bN̈łȂƂrbg𗧂Ă
$                   // [UX^bN̈̏ꍇTCB̃AhX
$                   // TCB̃AhXP2̈Ȃ̂ŃAhX̍ŏʃrbg1
$                   // Ăł͍ŏʃrbg0ɂ
                    $page_table_entry = 0x00000000$

$                   // یL[f[^̈Zbg
                    $IF (MO.ACPTN1[moid] & DEFAULT_ACPTN[domid]) != 0$
$                       // ݉\
                        $page_mp_info = page_mp_info | 0x01$
                    $END$
                    $IF (MO.ACPTN2[moid] & DEFAULT_ACPTN[domid]) != 0$
$                       // Ǎ݁Cs\
                        $page_mp_info = page_mp_info | 0x02$
                    $END$
                    $IF page_mp_info == 0x03$
$                       // [U[hRWX\
                        $page_table_entry = page_table_entry | (0x03 << 5)$
                    $ELIF page_mp_info == 0x02$
$                       // [U[hRX\
                        $page_table_entry = page_table_entry | (0x02 << 5)$
                    $ELIF page_mp_info == 0x00$
                        $IF (MO.MEMATR[moid] & TA_NOWRITE) == 0$
$                           // [hRWX\
                            $page_table_entry = page_table_entry | (0x01 << 5)$
                        $ELIF page_mp_info == 0x02$
$                           // [hRX\
                            $page_table_entry = page_table_entry | (0x00 << 5)$
                        $END$
                    $ELSE$
                        $ERROR$$FORMAT(_("non support memory protection attribute: ACPTN1 = %1%, ACPTN2 = %2%", MO.ACPTN1[moid], MO.ACPTN2[moid]))$$END$
                    $END$

$                   // LԃrbgZbg
$                   // ̃IuWFNgȂ΋Lԃrbg𗧂Ă
                    $IF (MO.ACPTN2[moid] == DEFAULT_ACPTN[TDOM_NONE])$
                        $IF (((MO.MEMATR[moid] & TA_NOWRITE) != 0) || ((MO.ACPTN1[moid] == DEFAULT_ACPTN[TDOM_NONE])))$
                            $page_table_entry = page_table_entry | (0x01 << 1)$
                        $END$
                    $END$

$                   // y[WTCYrbgZbg
$                   // ׂ4KB
                    $page_table_entry = page_table_entry | (0x01 << 4)$

$                   // LbVO\rbgZbg
                    $IF (MO.MEMATR[moid] & TA_UNCACHE) == 0$
                        $page_table_entry = page_table_entry | (0x01 << 3)$
                    $END$
$                   // CgX[rbgZbg
$                    $page_table_entry = page_table_entry | (0x01 << 0)$

$                   // _[eBrbgZbg
                    $page_table_entry = page_table_entry | (0x01 << 2)$

$                   // LrbgZbg
                    $page_table_entry = page_table_entry | (0x01 << 8)$

                    $page_table_entry = VALUE("", +page_table_entry)$
                    $TAB$(uint32_t)$FORMAT("0x%xU", +page_table_entry)$
                $ELSE$
$                   // [UX^bN
$                   // CgX[
$                    $TAB$(uint32_t)$FORMAT("0x0000017dU")$
$                   // CgobN
                    $TAB$(uint32_t)$FORMAT("0x0000017cU")$
$                   // LbVOs
$                    $TAB$(uint32_t)$FORMAT("0x00000174U")$
                $END$
            $END$
            $IF !LENGTH(MO.SUPPRESSLIMIT[moid])$
                $IF !LENGTH(MO.SUPPRESSSTART[moid])$,$NL$$END$
                $TAB$(uint32_t)0x0U
            $END$
        $END$
    $NL$};$NL$$NL$
    $END$
$END$

$NL$


